/* $Id: mixer.h,v 4.14 1999/10/03 15:44:56 lcs Exp $ */

/*
     AHI - Hardware independent audio subsystem
     Copyright (C) 1996-1999 Martin Blom <martin@blom.org>
     
     This library is free software; you can redistribute it and/or
     modify it under the terms of the GNU Library General Public
     License as published by the Free Software Foundation; either
     version 2 of the License, or (at your option) any later version.
     
     This library is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     Library General Public License for more details.
     
     You should have received a copy of the GNU Library General Public
     License along with this library; if not, write to the
     Free Software Foundation, Inc., 59 Temple Place - Suite 330, Cambridge,
     MA 02139, USA.
*/

#ifndef _MIXER_H_
#define _MIXER_H_

#include <config.h>
#include <CompilerSpecific.h>
#include "ahi_def.h"

#include "addroutines.h"

ULONG
InternalSampleFrameSize( ULONG sampletype );

BOOL
InitMixroutine ( struct AHIPrivAudioCtrl *audioctrl );

void
CleanUpMixroutine ( struct AHIPrivAudioCtrl *audioctrl );

void
calcMasterVolumeTable ( struct AHIPrivAudioCtrl *audioctrl );

BOOL
initSignedTable ( struct AHIPrivAudioCtrl *audioctrl );

void
calcSignedTable ( struct AHIPrivAudioCtrl *audioctrl );

BOOL
initUnsignedTable ( struct AHIPrivAudioCtrl *audioctrl );

void
calcUnsignedTable ( struct AHIPrivAudioCtrl *audioctrl );

void
SelectAddRoutine ( Fixed     VolumeLeft,
                   Fixed     VolumeRight,
                   ULONG     SampleType,
                   struct    AHIPrivAudioCtrl *audioctrl,
                   LONG     *ScaleLeft,
                   LONG     *ScaleRight,
                   ADDFUNC **AddRoutine );

#if !defined( VERSIONPPC )
void ASMCALL
MixGeneric ( REG(a0, struct Hook *Hook),
             REG(a1, void *dst),
             REG(a2, struct AHIPrivAudioCtrl *audioctrl) );
#else
void
MixGeneric ( struct Hook *Hook,
             void *dst,
             struct AHIPrivAudioCtrl *audioctrl );
#endif

LONG
CalcSamples ( Fixed64 Add,
              ULONG   Type,
              Fixed64 LastOffset,
              Fixed64 Offset );

#endif /* _MIXER_H_ */
