
#include "common/extern.h"
#include "common/Grab_mcc.h"
#include "common/subtasksupp.h"

/// "New"

ULONG
mLPrefsWin_New (struct IClass *cl, Object * obj, struct opSet *msg)
{
  APTR POP_DOWNDIR, STR_DOWNDIR, POP_BUTTON, STR_INDEXNAME, NUM_MAXCON;
  APTR BT_Use, BT_Reset, BT_Cancel;
// *INDENT-OFF*
  obj = (Object *) DoSuperNew(cl, obj,
                                MUIA_Window_Title, STRING (LPREFS_Wintitle, "Project Settings"),
                                MUIA_Window_ID, MAKE_ID('E','W','I','N'),
                                MUIA_HelpNode, "WIN_LPREFS",

                                WindowContents, VGroup,
                                    Child, VGroup,
                                        InnerSpacing(2,2),

                                        Child, VGroup,
                                          MUIA_Frame, MUIV_Frame_Group,
                                          MUIA_Background, MUII_GroupBack,
                                          MUIA_FrameTitle, STRING (PREFS_Downloadto, "Download to: "),
                                          MUIA_ShortHelp, STRING (ShortHelp_Download, "\33cInsert here the drawer where\nurls will be saved"),

                                          Child, POP_DOWNDIR = PopaslObject,
                                            MUIA_Popstring_String, STR_DOWNDIR = KeyStringDrop("net/",1024,'d'),
                                            MUIA_Popstring_Button, POP_BUTTON = PopButton(MUII_PopDrawer),
                                            ASLFR_TitleText  , STRING (PREFS_Seldir, "Please select a drawer..."),
                                            ASLFR_DrawersOnly, TRUE,
                                          End,
                                        End,

                                        Child, VGroup,
                                          //MUIA_Group_Columns, 2,
                                          MUIA_Frame, MUIV_Frame_Group,
                                          MUIA_Background, MUII_GroupBack,
                                          MUIA_FrameTitle, STRING (PREFS_Download, "Indexfile name"),

                                          Child, STR_INDEXNAME = StrDropObject,
                                              MUIA_String_MaxLen, 30,
                                              MUIA_String_AdvanceOnCR, TRUE,
                                              MUIA_String_Contents, "index.html",
                                              //MUIA_HelpNode, "Title_string",
                                          End,
                                        End,

                                        Child, VGroup,
                                          MUIA_Frame, MUIV_Frame_Group,
                                          MUIA_Background, MUII_GroupBack,
                                          MUIA_FrameTitle, STRING (PREFS_MaxConnections, "Maximun number of connections"),
                                          MUIA_ShortHelp, STRING (ShortHelp_MaxConnections, "\33cSelect the maximun number\nof useable sockets"),

                                          // First Column
                                          Child, NUM_MAXCON = SliderObject,
                                            MUIA_Slider_Horiz, TRUE,
                                            MUIA_Slider_Max,      16,
                                            MUIA_Slider_Min,      1,
                                            #ifndef __DEMO__
                                            MUIA_Slider_Level,    4,
                                            #else
                                            MUIA_Slider_Level,    1,
                                            #endif
                                          End,
                                        End,
                                    End,

                                    Child, HGroup,
                                        Child, BT_Use    = SimpleButton(STRING (MSG_Use,   "_Use")),
                                        Child, BT_Reset  = SimpleButton(STRING (MSG_Reset, "_Reset")),
                                        Child, BT_Cancel = SimpleButton(STRING (MSG_Cancel,"_Cancel")),
                                    End,

                                End,
                                TAG_MORE, msg->ops_AttrList);
// *INDENT-ON*





  if (obj)
    {
      register struct LPrefsWinData *data = (struct LPrefsWinData *) INST_DATA (cl, obj);

      data->POP_Downdir = POP_DOWNDIR;
      data->STR_Downdir = STR_DOWNDIR;
      data->STR_Indexname = STR_INDEXNAME;
      data->NUM_Maxcon = NUM_MAXCON;

      data->BT_Use = BT_Use;
      data->BT_Reset = BT_Reset;
      data->BT_Cancel = BT_Cancel;

      if ((data->parent = (APTR) GetTagData (MUIA_LPrefsWin_ProjWin, NULL, msg->ops_AttrList)))
        data->pprefs = (struct proj_prefs *) xget ((Object *) data->parent, MUIA_ProjWin_ProjPrefs);
      else
        data->pprefs = NULL;

      /* The given hook will be called after every change */

      // Menus
      /*DoMethod ((Object *) MN_LOAD,
         MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
         GObject->App, 2, MUIM_CallHook, &PasteHook); */

/*      DoMethod ((Object *) MN_CLOSE,
   MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
   obj, 3, MUIM_Set, MUIA_Window_CloseRequest, TRUE);
 */
      // Buttons
      DoMethod ((ULONG *) BT_Use, MUIM_Notify, MUIA_Pressed, FALSE,
                obj, 2, MUIM_LPrefsWin_Use, NULL);

      DoMethod ((ULONG *) BT_Reset, MUIM_Notify, MUIA_Pressed, FALSE,
                obj, 2, MUIM_LPrefsWin_Reset, NULL);

      DoMethod ((ULONG *) BT_Cancel, MUIM_Notify, MUIA_Pressed, FALSE,
                obj, 3, MUIM_Set, MUIA_Window_CloseRequest, TRUE);


      DoMethod ((ULONG *) obj,
                MUIM_Window_SetCycleChain,

                STR_DOWNDIR,
                POP_BUTTON,
                STR_INDEXNAME,
                NUM_MAXCON,

                BT_Use,
                BT_Reset,
                BT_Cancel,
                NULL);

      DoMethod ((ULONG *) oa->App, OM_ADDMEMBER, obj);
      DoMethod (obj, MUIM_LPrefsWin_Reset, data->pprefs);
      set ((ULONG *) obj, MUIA_Window_Open, TRUE);

      return ((ULONG) obj);
    }
  else
    {
      D (printf ("LPrefsWin: New error\n"));
      error_req (STRING (MSG_OK, "*_OK"), STRING (ERR_NOMEM, "Out of Memory"));
    }

  return (NULL);
}
///

/// "Dispose"
ULONG
mLPrefsWin_Dispose (struct IClass * cl, Object * obj, Msg msg)
{
  register struct LPrefsWinData *data = (struct LPrefsWinData *) INST_DATA (cl, obj);

  /*if (data->wnd)
     {
     Remove ((struct Node *) data->wnd);
     FreeSPooled (gd.gd_pool, data->wnd, sizeof (struct EditWinNode));
     data->wnd = NULL;
     } */

  DoMethod ((ULONG *) oa->App, OM_REMMEMBER, obj);

  return (DoSuperMethodA (cl, obj, msg));
}
///

/// "Set"
ULONG
mLPrefsWin_Set (struct IClass * cl, Object * obj, Msg msg)
{
  register struct LPrefsWinData *data = (struct LPrefsWinData *) INST_DATA (cl, obj);

  struct TagItem *tags, *tag;
  for (tags = ((struct opSet *) msg)->ops_AttrList; (tag = (struct TagItem *) NextTagItem (&tags));)
    {
      switch (tag->ti_Tag)
        {

        case MUIA_UrlEditWin_ProjWin:
          data->parent = (APTR) tag->ti_Data;
          break;

        case MUIA_Window_CloseRequest:
          if (tag->ti_Data == TRUE)
            {
              DoMethod ((ULONG *) oa->App, MUIM_Application_PushMethod, obj, 2, OM_DISPOSE, NULL);
              set (data->parent, MUIA_ProjWin_Sleep, FALSE);
              return (NULL);
            }
          break;

        }
    }

  return (DoSuperMethodA (cl, obj, msg));
}
///

#ifndef __DEMO__

/// "Use"
ULONG
mLPrefsWin_Use (struct IClass * cl, Object * obj, Msg msg)
{
  register struct LPrefsWinData *data = (struct LPrefsWinData *) INST_DATA (cl, obj);
  char *buffer, *buffer2, *tmp;
  LONG num_buffer;

  get (data->STR_Downdir, MUIA_String_Contents, &buffer);
  get (data->STR_Indexname, MUIA_String_Contents, &buffer2);

  // chek if there are valid downdir and indexname
  if (buffer && *buffer != '\0')
    if (buffer2 && *buffer2 != '\0')
      {
        if ((tmp = newstrcpy (gd.gd_pool, buffer)))
          {
            ObtainSemaphore (&data->pprefs->sema);
            FreeVecPooled (gd.gd_pool, data->pprefs->strdowndir);
            data->pprefs->strdowndir = tmp;
            ReleaseSemaphore (&data->pprefs->sema);

            if ((tmp = newstrcpy (gd.gd_pool, buffer2)))
              {
                ObtainSemaphore (&data->pprefs->sema);
                FreeVecPooled (gd.gd_pool, data->pprefs->indexname);
                data->pprefs->indexname = tmp;
                ReleaseSemaphore (&data->pprefs->sema);
              }

            get (data->NUM_Maxcon, MUIA_Numeric_Value, &num_buffer);

            ObtainSemaphore (&data->pprefs->sema);
            data->pprefs->socknum = num_buffer;
            ReleaseSemaphore (&data->pprefs->sema);

            return ((ULONG) set (obj, MUIA_Window_CloseRequest, TRUE));


          }
      }
  //else req error dir...


  return (NULL);
}
///

#else /* DEMO VERSION */

/// "Use"
ULONG
mLPrefsWin_Use (struct IClass * cl, Object * obj, Msg msg)
{
  //register struct PrefsWinData *data = (struct PrefsWinData *) INST_DATA (cl, obj);
  error_req (STRING (MSG_OK, "*_OK"), "\033c%s", STRING (DEMO_NOPREFS, "In this DEMO version\nyou can't change prefs!"));
  return (NULL);
}
///

#endif

/// "Reset"
ULONG
mLPrefsWin_Reset (struct IClass * cl, Object * obj, Msg msg)
{
  register struct LPrefsWinData *data = (struct LPrefsWinData *) INST_DATA (cl, obj);

  if (data->pprefs)
    {
      ObtainSemaphore (&data->pprefs->sema);
      set (data->STR_Downdir, MUIA_String_Contents, data->pprefs->strdowndir);
      set (data->STR_Indexname, MUIA_String_Contents, data->pprefs->indexname);
      set (data->NUM_Maxcon, MUIA_Numeric_Value, data->pprefs->socknum);
      ReleaseSemaphore (&data->pprefs->sema);
    }
  else
    {
      set (data->STR_Downdir, MUIA_String_Contents, "net/");
      set (data->STR_Indexname, MUIA_String_Contents, "index.html");
#ifndef __DEMO__
      set (data->NUM_Maxcon, MUIA_Numeric_Value, 4L);
#else
      set (data->NUM_Maxcon, MUIA_Numeric_Value, 1L);
#endif

    }

  return (NULL);
}
///

/// "PrefsWin_Dispatcher"
SAVEDS (ULONG)
LPrefsWin_Dispatcher (REG (a0, struct IClass * cl), REG (a2, Object * obj), REG (a1, Msg msg))
{
  switch (msg->MethodID)
    {
    case OM_NEW:
      return ((ULONG) mLPrefsWin_New (cl, obj, (struct opSet *) msg));

    case OM_DISPOSE:
      return ((ULONG) mLPrefsWin_Dispose (cl, obj, (Msg) msg));

    case OM_SET:
      return ((ULONG) mLPrefsWin_Set (cl, obj, (Msg) msg));

    case MUIM_LPrefsWin_Reset:
      return ((ULONG) mLPrefsWin_Reset (cl, obj, (Msg) msg));

    case MUIM_LPrefsWin_Use:
      return ((ULONG) mLPrefsWin_Use (cl, obj, (Msg) msg));
    }

  return (DoSuperMethodA (cl, obj, msg));
}
///
