
#include "mpg123.h"

#if defined(AMIGA) && !defined(POWERUP)
#define PPCOpen  Open
#define PPCWrite Write
#define PPCClose Close
#include "proto/dos.h"
#endif

int audio_open(struct audio_info_struct *ai)
{
  static char device[100];
  if(!ai)
    return -1;

  if(!ai->device) {
    sprintf(device,
	"AUDIO:V/200/PRI/1/BUF/300000/B/%d/C/%d/F/%d",
	(ai->format==AUDIO_FORMAT_SIGNED_16 ? 16 : 8),
	ai->channels,
	ai->rate);

    ai->device = device;
  }

  ai->fn = PPCOpen(ai->device,1005);
  if(ai->fn < 0)
  {
    fprintf(stderr,"Can't open %s!\n",ai->device);
    exit(1);
  }

  if(audio_reset_parameters(ai) < 0) {
    PPCClose(ai->fn);
    return -1;
  }
  return ai->fn;
}

int audio_reset_parameters(struct audio_info_struct *ai)
{
  int ret;
  ret = audio_set_format(ai);
  if(ret >= 0)
    ret = audio_set_channels(ai);
  if(ret >= 0)
    ret = audio_set_rate(ai);
  return ret;
}

int audio_rate_best_match(struct audio_info_struct *ai)
{
  return 0;
}

int audio_set_rate(struct audio_info_struct *ai)
{
  return 0;
}

int audio_set_channels(struct audio_info_struct *ai)
{
  return 0;
}

int audio_set_format(struct audio_info_struct *ai)
{
  int sample_size,fmts;

  if(ai->format == -1)
    return 0;

  return 0;
}

int audio_get_formats(struct audio_info_struct *ai)
{
  return AUDIO_FORMAT_SIGNED_16;
}

int audio_play_samples(struct audio_info_struct *ai,unsigned char *buf,int len)
{
  return PPCWrite(ai->fn,buf,len);
}

int audio_close(struct audio_info_struct *ai)
{
  if( ai->fn>0 )
    PPCClose(ai->fn);
  return 0;
}
