#ifndef _FOLDERS_H_
#define _FOLDERS_H_

#define REGULAR  0
#define INCOMING 1
#define OUTGOING 2
#define SENT     3
#define DELETED  4

struct Folder
{
    struct Folder *f_next;
    struct Folder *f_prev;
    char          *f_path;
    int            f_num;
    int            f_type;
};

extern int query_for_user(void);
extern void scan_folders(struct List *folders);
extern int build_folders_list(struct List *folders);
extern void free_folders_list(struct List *folders);
extern char *get_folder_path(struct List *folders, int type);
extern int get_folder_pos(struct List *folders, int type);
extern struct List *init_folder_list(void);

extern char current_user_path[];
extern struct List *open_folder_list(void);
extern void save_folder_list(struct List *folders);


#endif

