/*
**   YAM2NN - Usenet access for YAM p7 and newer
**   Copyright (C) 1999 Karol Bryd <kbryd@femina.com.pl>
**
**   This program is free software; you can redistribute it and/or
**   modify it under the terms of the GNU General Public License
**   as published by the Free Software Foundation; either version 2
**   of the License, or (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <proto/dos.h>
#include <dos/dos.h>
#include <proto/exec.h>
#include <stdio.h>

#define MAGIC 0x12ab93c2

struct Key
{
    ULONG magic;
    char name[64];
    ULONG checksum;
};

char *GetKey(void)
{
    BPTR keyfh;
    static struct Key key;
    ULONG a, checksum;

    keyfh=Open("YAM:YAM2NN.key", MODE_OLDFILE);
    if(keyfh)
    {
        Read(keyfh, &key, sizeof(struct Key));

        if(key.magic==MAGIC)
        {
            for(checksum=0, a=0; a<64; a++)
            {
                key.name[a]=key.name[a]-a-100;
                checksum+=key.name[a]+a;
            }

            if(checksum==key.checksum)
            {
                Close(keyfh);
                return(key.name);
            }
        }
        Close(keyfh);
    }
    return("*Unregistered*");
}

void CreateKey(char *name)
{
    BPTR keyfh;
    static struct Key key;
    ULONG a, checksum;

    strncpy(key.name, name, 64);

    for(checksum=0, a=0; a<64; a++)
    {
        checksum+=key.name[a]+a;
        key.name[a]=key.name[a]+a+100;
    }
    key.magic=MAGIC;
    key.checksum=checksum;
    keyfh=Open("YAM:YAM2NN.key", MODE_NEWFILE);
    Write(keyfh, &key, sizeof(struct Key));
    Close(keyfh);
}
/*
int main(int argc, char **argv)
{
//    CreateKey(argv[1]);
    printf("%s\n", GetKey());
}
*/
