/*
$Log: mui.c $
Revision 1.3  1999/04/14 16:13:27  kbryd
Added some RCS tags...

*/

/*
**   YAM2NN - Usenet access for YAM p7 and newer
**   Copyright (C) 1999 Karol Bryd <kbryd@femina.com.pl>
**
**   This program is free software; you can redistribute it and/or
**   modify it under the terms of the GNU General Public License
**   as published by the Free Software Foundation; either version 2
**   of the License, or (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "Yam2NN.c_rev.h"
#include "Yam2NN.h"
#include "get.h"
#include "skip.h"
#include "excl.h"

#include "yam2nn_cat.h"

/* Encoding types */
#define BASE64    1
#define SEVEN_BIT 2
#define EIGHT_BIT 3
#define BINARY    4
#define QUOTED    5
#define UNKNOWN   6

static char rcsid[] = "$Id: mui.c 1.3 1999/04/14 16:13:27 kbryd Exp kbryd $";

extern void abortdownload(void);

#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))

#define IMG \
     BodychunkObject,\
     MUIA_Bitmap_Width, SKIP_WIDTH,\
     MUIA_Bitmap_Height, SKIP_HEIGHT,\
     MUIA_FixWidth, SKIP_WIDTH,\
     MUIA_FixHeight, SKIP_HEIGHT,\
     MUIA_Bodychunk_Body, (UBYTE *)skip_body,\
     MUIA_Bodychunk_Compression, SKIP_COMPRESSION,\
     MUIA_Bodychunk_Masking, SKIP_MASKING,\
     MUIA_Bodychunk_Depth, SKIP_DEPTH,\
     MUIA_Bitmap_SourceColors, skip_colors,\
     MUIA_Bitmap_Transparent, 0,\
     End

#define IMG2 \
     BodychunkObject,\
     MUIA_Bitmap_Width, GET_WIDTH,\
     MUIA_Bitmap_Height, GET_HEIGHT,\
     MUIA_FixWidth, GET_WIDTH,\
     MUIA_FixHeight, GET_HEIGHT,\
     MUIA_Bodychunk_Body, (UBYTE *)get_body,\
     MUIA_Bodychunk_Compression, GET_COMPRESSION,\
     MUIA_Bodychunk_Masking, GET_MASKING,\
     MUIA_Bodychunk_Depth, GET_DEPTH,\
     MUIA_Bitmap_SourceColors, get_colors,\
     MUIA_Bitmap_Transparent, 0,\
     End

#define IMG3 \
     BodychunkObject,\
     MUIA_Bitmap_Width, EXCL_WIDTH,\
     MUIA_Bitmap_Height, EXCL_HEIGHT,\
     MUIA_FixWidth, EXCL_WIDTH,\
     MUIA_FixHeight, EXCL_HEIGHT,\
     MUIA_Bodychunk_Body, (UBYTE *)excl_body,\
     MUIA_Bodychunk_Compression, EXCL_COMPRESSION,\
     MUIA_Bodychunk_Masking, EXCL_MASKING,\
     MUIA_Bodychunk_Depth, EXCL_DEPTH,\
     MUIA_Bitmap_SourceColors, excl_colors,\
     MUIA_Bitmap_Transparent, 0,\
     End


APTR  app = 0,
      window = 0,
      transfer = 0,
      action = 0,
      get2 = 0,
      skip = 0,
      message,
      bytes,
      stop,
      ngname,
      remained,
      nlist1,
      skip,
      keep,
      perform,
      skipall,
      preselectwindow,
      infotxt,
      ng,
      popup,
      next,
      root_group,
      toggle;

extern char  msg_transfer[],
      msg_action[],
      msg_bytes[],
      msg_message[],
      msg_ngname[],
      msg_remained[],
      msg_preinfo[];

extern BPTR currentdir, oldcurrentdir;
extern void *listpool;
extern long sizetotal, articles;
extern struct MsgPort *timerport, *port;
extern struct timerequest *timerreq;
extern struct Library *MUIMasterBase, *MiamiBase;
extern BOOL timerdev;
extern BOOL sendtime;

extern APTR info;
extern SAVEDS void InfoWindow(void);
extern SAVEDS void SkipNewsgroup(void);

struct Hook hook={{0, 0}, (void *)(abortdownload), NULL, NULL};

void updategadgets(int type)
{
    set(transfer, MUIA_Text_Contents, msg_transfer);
    set(message, MUIA_Gauge_InfoText, msg_message);
    set(bytes, MUIA_Gauge_InfoText, msg_bytes);
    set(action, MUIA_Text_Contents, msg_action);

    if(type == 0)
        set(ngname, MUIA_Text_Contents, msg_ngname);

    set(ng, MUIA_Text_Contents, msg_ngname);
    set(remained, MUIA_Text_Contents, msg_remained);
}

// some MIME decoding functions

char base64[66]={"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                 "abcdefghijklmnopqrstuvwxyz"
                 "0123456789+/="};

SAVEDS __inline int get_hex(char octet)
{
    register char n;

    for(n = 0; n < sizeof(base64); n++)
        if(octet == base64[n])
            return(n);

    return(-1);
}

SAVEDS unsigned char *decode_word_4(unsigned char *buf, long *pos)
{
    static unsigned char longword[4];
    int c1, c2, c3, c4;
    int len;

    len = 3;

    if(buf[*pos] == '\n')
        (*pos)++;

    c1 = get_hex(buf[*pos]);

    if(buf[*pos + 1] == '\n')
        (*pos)++;

    c2 = get_hex(buf[*pos + 1]);

    if(buf[*pos + 2] == '\n')
        (*pos)++;

    c3 = get_hex(buf[*pos + 2]);

    if(buf[*pos + 3] == '\n')
        (*pos)++;

    c4 = get_hex(buf[*pos + 3]);

    if ((c1 > 63) || (c2 > 63) || (c3 > 64) || (c4 > 64))
        return(NULL);

    longword[0] = ((c1 << 2) & 0xfc);
    longword[0] = (longword[0] | ((c2 >> 4) & 0x03));

    longword[1] = ((c2 << 4) & 0xf0);
    longword[1] = (longword[1] | ((c3 >> 2) & 0x0f));

    longword[2] = ((c3 << 6) & 0xc0);
    longword[2] = (longword[2] | (c4 & 0x3f));

    if ((c3 == 64) && (c4 == 64))
        longword[1] = 0;
    else if (c4 == 64)
        longword[2] = 0;
    else
        longword[3] = 0;

    return(longword);
}

SAVEDS char *decode_one_word(char *encoded_word)
{
    static char output_buf[1024];
    char charset[100];
    char *next;
    char current;
    char encoding;
    int out_cnt = 0;

    if(strncmp(encoded_word, "=?", 2))
        return(NULL);

    next = stptok(&encoded_word[2], charset, sizeof(charset), "?");

    next++;
    if((*next == 'q') || (*next == 'Q'))
        encoding = QUOTED;
    else
        encoding = BASE64;

    next += 2;

    if(encoding == BASE64)
    {
        int pos = 0;
        char *quad;

        while(1)
        {
            quad = decode_word_4(next, &pos);

            output_buf[out_cnt++] = quad[0];
            output_buf[out_cnt++] = quad[1];
            output_buf[out_cnt++] = quad[2];

            if(strlen(quad) < 3)
            {
                while((*next != '\n') && (*next != 0))
                    next++;

                next++;
                if(*next == ' ')
                    next += 12;
                else
                    break;
            }
            next += 4;
        }
        output_buf[out_cnt++] = 0;
    }
    else
    {
        while(1)
        {
            if((out_cnt > 1000) || (*next == 0))
            {
                output_buf[out_cnt] = 0;
                break;
            }

            if((*next == '?') && (*(next + 1) == '='))
            {
                int more = FALSE;

                next += 2;
                while((*next != 0) && (*next != '\n'))
                {
                    if((*next == '=') && (*(next + 1) == '?'))
                    {
                        next += 15;

                        more = TRUE;
                        break;
                    }

                    output_buf[out_cnt++] = *next;
                    next++;
                }
                if(!more)
                    break;
            }
            if(*next == '=')
            {
                unsigned int octet;

                sscanf(next + 1, "%2x", &octet);
                output_buf[out_cnt++] = octet;
                next += 3;
            }
            else if(*next == '_')
            {
                output_buf[out_cnt++] = ' ';
                next++;
            }
            else
            {
                output_buf[out_cnt++] = *next;
                next++;
            }
        }
        output_buf[out_cnt] = 0;
    }
    return(output_buf);
}

SAVEDS int is_encoded(char *word)
{
    if(strnicmp(word, "=?", 2) == 0)
        return(TRUE);
    else
        return(FALSE);
}

SAVEDS int CopyWordHeader(char *in, char *out)
{
    int i = 0, o = 0;
    int k = 0;

    strncpy(out, in, 2);

    while(k != 3)
    {
        while(in[i] != '?')
            out[o++] = in[i++];

        out[o++] = in[i++];

        k++;
    }
    out[o] = 0;
    return(i);
}

SAVEDS char *rzDecodeWord(char *in)
{
    static char out[1024];
    static char tmp[1024];
    int n, o;

    n = 0;
    o = 0;

    strcpy(out, "");
    while(in[n])
    {
        if(is_encoded(&in[n]))
        {
            tmp[o] = 0;
            strcat(out, tmp);

            n += CopyWordHeader(&in[n], tmp);
            o = strlen(tmp);

            while(in[n])
            {
                if(strncmp(&in[n], "?=", 2) == 0)
                {
                    tmp[o] = 0;
                    strcat(tmp, "?=");
                    n += 2;
                    o += 2;
                    break;
                }
                tmp[o++] = in[n++];
            }
            tmp[o] = 0;
            strcat(out, decode_one_word(tmp));
            o = 0;
        }
        if(in[n] == 0)
            break;
        tmp[o++] = in[n++];
    }
    if(o > 0)
    {
        tmp[o] = 0;
        strcat(out, tmp);
    }

    return(out);
}

static char *p, from[100], date[20];

// display hook of preselect window

SAVEDS ASM LONG DisplayHook(register __a2 char **col GNUCREG(a2), register __a1 struct Article *art GNUCREG(a1))
{
    static char buf[20];
    static char size[20], score[20];

    if(art)
    {
        strcpy(from, art->From);
        sprintf(buf, "%ld", art->Num);

        *col++ = buf;

        sprintf(score, "%ld", art->Score);
        *col++ = score;

        if(art->Status)
            *col++ = "\033o[1]";
        else
            *col++ = "\033o[0]";

        *col++ = art->Subject;

        if(p=strchr(from, '('))
            *col++ = strtok(p + 1, ")");
        else
        {
            p = strchr(from, '\"');
            if(p)
                *col++ = strtok(p + 1, "\"");
            else
                *col++ = strtok(from, "<");
        }

        if(art->Date[3] == ',')
            strncpy(date, &art->Date[5], 21);
        else
            strncpy(date, art->Date, 21);

        date[19] = 0;

        *col++ = date;
        sprintf(size, "%ld", art->Size);
        *col = size;
    }
    else
    {
        *col++ = "#";
        *col++ = (char *)msgScore;
        *col++ = (char *)msgStatus;
        *col++ = (char *)msgSubject;
        *col++ = (char *)msgAuthor;
        *col++ = (char *)msgDate;
        *col   = (char *)msgSize;
    }
    return(0);
}

struct Hook display_hook={{NULL, NULL}, (void *)(DisplayHook), NULL, NULL};

ASM SAVEDS APTR ConstructHook(register __a2 APTR pool GNUCREG(a2), register __a1 struct Article *art GNUCREG(a1))
{
    struct Article *newart;
    char *decoded;

    newart = AllocPooled(pool, sizeof(struct Article));
    newart->Num = art->Num;
    newart->Size = art->Size;
    newart->Lines = art->Lines;
    newart->Status = art->Status;
    newart->Score = art->Score;

    strncpy(newart->FullName, art->FullName, 108);
    strncpy(newart->FileName, art->FileName, 20);

    decoded = rzDecodeWord(art->From);
    if(newart->From = AllocPooled(pool, strlen(decoded) + 1))
        strcpy(newart->From, decoded);

    free(art->From);

    decoded = rzDecodeWord(art->Subject);
    if(newart->Subject = AllocPooled(pool, strlen(decoded) + 1))
        strcpy(newart->Subject, decoded);

    free(art->Subject);

    if(newart->Date = AllocPooled(pool, strlen(art->Date) + 1))
        strcpy(newart->Date, art->Date);
    free(art->Date);

    if(newart->Msg_ID = AllocPooled(pool, strlen(art->Msg_ID) + 1))
        strcpy(newart->Msg_ID, art->Msg_ID);
    free(art->Msg_ID);

    if(art->References)
    {
        if(newart->References = AllocPooled(pool, strlen(art->References) + 1))
            strcpy(newart->References, art->References);

        free(art->References);
    }
    else
        newart->References = 0;

    return(newart);
}

ASM SAVEDS void DestructHook(register __a2 APTR pool GNUCREG(a2), register __a1 struct Article *art GNUCREG(a1))
{
    FreePooled(pool, art->From, strlen(art->From) + 1);
    FreePooled(pool, art->Subject, strlen(art->Subject) + 1);
    FreePooled(pool, art->Msg_ID, strlen(art->Msg_ID) + 1);
    FreePooled(pool, art->Date, strlen(art->Date) + 1);
    if(art->References)
        FreePooled(pool, art->References, strlen(art->References) + 1);
    FreePooled(pool, art, sizeof(struct Article));
}

struct Hook construct_hook={{NULL, NULL}, (void *)(ConstructHook), NULL, NULL};
struct Hook destruct_hook={{NULL, NULL}, (void *)(DestructHook), NULL, NULL};

// toggle status of selected message

ASM SAVEDS void ChangeStatus(register __a1 long *pos GNUCREG(a1))
{
    struct Article *entry;
    int nextpos;
    extern int skippedarticles;

    DoMethod(nlist1, MUIM_NList_GetEntry, *pos, &entry);

    if(entry)
    {
        if(entry->Status)
            entry->Status = FALSE;
        else
            entry->Status = TRUE;

        DoMethod(nlist1, MUIM_NList_Redraw, *pos);
    }

    nextpos = 0;
    skippedarticles = 0;
    while(1)
    {
        DoMethod(nlist1, MUIM_NList_GetEntry, nextpos, &entry);
        nextpos++;

        if(!entry)
            break;

        if(!entry->Status)
            skippedarticles++;
    }
    sprintf(msg_preinfo, (char *)msgPreInfo, articles, skippedarticles);
    set(infotxt, MUIA_Text_Contents, msg_preinfo);
}

// as above but for multiselect

ASM SAVEDS void MultiChangeStatus(register __a1 long *type GNUCREG(a1))
{
    struct Article *entry;
    long nextpos = MUIV_NList_NextSelected_Start;
    long a, ent;
    extern int skippedarticles;

    set(nlist1, MUIA_NList_Quiet, MUIV_NList_Quiet_Full);


    if((*type == 1) || (*type == 2))
    {
        while(1)
        {
            DoMethod(nlist1, MUIM_NList_NextSelected, &nextpos);
            if(nextpos == MUIV_NList_NextSelected_End)
                break;

            DoMethod(nlist1, MUIM_NList_GetEntry, nextpos, &entry);

            if(entry)
            {
                if(*type == 1)
                    entry->Status = FALSE;
                else if(*type == 2)
                    entry->Status = TRUE;
                DoMethod(nlist1, MUIM_NList_Redraw, nextpos);
            }
        }

        nextpos = 0;
        skippedarticles = 0;
        while(1)
        {
            DoMethod(nlist1, MUIM_NList_GetEntry, nextpos, &entry);
            nextpos++;

            if(!entry)
                break;

            if(!entry->Status)
                skippedarticles++;
        }
        sprintf(msg_preinfo, (char *)msgPreInfo, articles, skippedarticles);
        set(infotxt, MUIA_Text_Contents, msg_preinfo);
    }
    else
    {
        get(nlist1, MUIA_NList_Entries, &ent);
        for(a = 0; a < ent; a++)
        {
            DoMethod(nlist1, MUIM_NList_Select, a, MUIV_NList_Select_Ask, &nextpos);
            DoMethod(nlist1, MUIM_NList_GetEntry, a, &entry);
            if(!entry)
                break;

            if(nextpos == MUIV_NList_Select_Off)
                if(entry->Status)
                    entry->Status = 0;
                else
                    entry->Status = 1;

            DoMethod(nlist1, MUIM_NList_Redraw, a);
        }
    }
    set(nlist1, MUIA_NList_Quiet, FALSE);
}

struct Hook change_status_hook={{NULL, NULL}, (void *)(ChangeStatus), NULL, NULL};
struct Hook change_hook={{NULL, NULL}, (void *)(MultiChangeStatus), NULL, NULL};

struct Hook skip_hook={{NULL, NULL}, (void *)(SkipNewsgroup), NULL, NULL};
struct Hook info_hook={{NULL, NULL}, (void *)(InfoWindow), NULL, NULL};

long sort_method = 0;
unsigned long sort_type = 0;

// compare hook - it needs to be completed

long ASM SAVEDS compare(register __a1 struct Article *s1 GNUCREG(a1), register __a2 struct Article *s2 GNUCREG(a2))
{
    long ret;

    switch(sort_method)
    {
        case 1:
            ret = s1->Score - s2->Score;
            break;
        case 6:
            ret = s1->Size - s2->Size;
            break;
        case 3:
            ret = stricmp(s1->Subject, s2->Subject);
            break;
        case 4:
            ret = stricmp(s1->From, s2->From);
            break;
    }

    if(sort_type == MUIV_NList_TitleMark_Down)
        ret = -ret;

    return(ret);
}

struct Hook compare_hook={{NULL, NULL}, (void *)(compare), NULL, NULL};

// MUIM_NList_TitleMark and sorting stuff

SAVEDS ASM SortList(register __a1 long *col)
{
    sort_method = *col;

    get(nlist1, MUIA_NList_TitleMark, &sort_type);

    sort_type &= MUIV_NList_TitleMark_TypeMask;

    DoMethod(nlist1, MUIM_NList_Sort);
}

struct Hook title_click_hook={{NULL, NULL}, (void *)(SortList), NULL, NULL};

SAVEDS ASM ReverseSort(register __a1 long *col)
{
    unsigned long sort_type;

    get(nlist1, MUIA_NList_TitleMark, &sort_type);
    sort_type &= MUIV_NList_TitleMark_TypeMask;

    if(sort_type == MUIV_NList_TitleMark_Down)
        set(nlist1, MUIA_NList_TitleMark, MUIV_NList_TitleMark_Up | *col);
    else
        set(nlist1, MUIA_NList_TitleMark, MUIV_NList_TitleMark_Down | *col);
}

struct Hook reverse_sort_hook={{NULL, NULL}, (void *)(ReverseSort), NULL, NULL};

APTR initmui(void)
{
    app = ApplicationObject,
        MUIA_Application_Title      , "Yam2NN",
        MUIA_Application_Version    , VERSTAG,
        MUIA_Application_Copyright  , "1998, Karol Bryd",
        MUIA_Application_Author     , "Karol Bryd",
        MUIA_Application_Description, (char *)msgDescription,

        SubWindow, window = WindowObject,
            MUIA_Window_Title, (char *)msgMailTransfer,
            MUIA_Window_ID   , MAKE_ID('Y','2','N','N'),
            MUIA_Window_Activate, FALSE,
            WindowContents, VGroup,
                InnerSpacing(4, 3),
                Child, root_group = VGroup, GroupSpacing(0), MUIA_Window_Width, MUIV_Window_Width_MinMax(130),
                    MUIA_Frame, MUIV_Frame_Group, MUIA_FrameTitle, msgStatus,

                    Child, ngname=TextObject, NoFrame, MUIA_Text_Contents, msg_ngname ,End,
                    Child, HGroup,
                        Child, VGroup,
                            Child, VGroup, TextFrame,
                                Child, transfer=TextObject, NoFrame, MUIA_Text_Contents, msg_transfer ,End,
                                Child, remained=TextObject, NoFrame, MUIA_Text_Contents, msg_remained ,End,
                            End,
                            Child, action=TextObject, TextFrame, MUIA_Text_Contents, msg_action, End,
                        End,
                        Child, VGroup, MUIA_Group_SameSize, TRUE,
                            Child, message=GaugeObject, TextFrame, MUIA_Gauge_Horiz, TRUE, MUIA_Gauge_InfoText, msg_message, End,
                            Child, bytes=GaugeObject, TextFrame, MUIA_Gauge_Horiz, TRUE, MUIA_Gauge_InfoText, msg_bytes, End,
                            Child, HGroup,
                                Child, stop=SimpleButton(msgAbort),
                                Child, next=SimpleButton(msgSkip),
                                Child, popup=PopButton(MUII_PopUp),
                            End,
                        End,
                    End,
                    Child, VSpace(2),
                End,
                Child, VSpace(1),
                End,
            End,
            SubWindow, preselectwindow = WindowObject,
                MUIA_Window_Title, (char *)msgPreselectWindow,
                MUIA_Window_ID   , MAKE_ID('Y','P','R','E'),
                WindowContents, VGroup,
                    Child, ng = TextObject, TextFrame, MUIA_Text_Contents, msg_ngname, End,
                    Child, HGroup,
                        Child, skip = KeyButton((char *)msgSkipMarked, 's'),
                        Child, keep = KeyButton((char *)msgKeepMarked, 'k'),
                        Child, toggle = KeyButton("Toggle selected", 'g'),
                    End,
                    Child, HGroup,
                        Child, perform=KeyButton((char *)msgStart, 't'),
                        Child, skipall=KeyButton((char *)msgSkipThisNG, 'p'),
                    End,
                    Child, infotxt=TextObject, TextFrame, MUIA_Text_Contents, msg_preinfo, End,
                    Child, nlist1 = NListviewObject,
                        MUIA_CycleChain, 1,
                        MUIA_NListview_NList, NListObject,
                            MUIA_NList_DefaultObjectOnClick, TRUE,
                            MUIA_NList_Title, TRUE,
                            MUIA_NList_CompareHook, &compare_hook,
                            MUIA_NList_ConstructHook, &construct_hook,
                            MUIA_NList_DestructHook, &destruct_hook,
                            MUIA_NList_DisplayHook, &display_hook,
                            MUIA_NList_MultiSelect, MUIV_NList_MultiSelect_Default,
                            MUIA_NList_Imports, MUIV_NList_Imports_All,
                            MUIA_NList_Exports, MUIV_NList_Exports_All,
                            MUIA_NList_Format, "BAR,BAR,BAR,BAR,BAR,BAR,BAR",
                            MUIA_NList_AutoVisible, TRUE,
                            MUIA_NList_TitleSeparator, TRUE,
                            MUIA_NList_EntryValueDependent, TRUE,
                            MUIA_NList_MinColSortable, 0,
                            MUIA_NList_TitleMark, (MUIV_NList_TitleMark_Box | 0) ,
                            End,
                        End,
                End,
            End,
        End;

    info = NListviewObject,
        MUIA_CycleChain, 1,
        MUIA_NListview_NList, NListObject,
            MUIA_NList_Title, FALSE,
            MUIA_NList_AutoVisible, TRUE,
            MUIA_NList_Input, FALSE,
            MUIA_NList_DestructHook, MUIV_NList_DestructHook_String,
            MUIA_NList_ConstructHook, MUIV_NList_ConstructHook_String,
            End,
        End;

    DoMethod(next, MUIM_Notify, MUIA_Pressed, FALSE,
        next, 2, MUIM_CallHook, &skip_hook);

    DoMethod(popup, MUIM_Notify, MUIA_Pressed, FALSE,
        app, 2, MUIM_CallHook, &info_hook);

    DoMethod(window, MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
        app, 2, MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);

    DoMethod(preselectwindow, MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
        app, 2, MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);

    DoMethod(stop, MUIM_Notify, MUIA_Pressed, TRUE,
        stop, 2, MUIM_CallHook, &hook);

    DoMethod(nlist1, MUIM_Notify, MUIA_NList_DoubleClick, MUIV_EveryTime,
        nlist1, 3, MUIM_CallHook, &change_status_hook, MUIV_TriggerValue);

    DoMethod(skip, MUIM_Notify, MUIA_Pressed, FALSE,
        skip, 3, MUIM_CallHook, &change_hook, 1);

    DoMethod(keep, MUIM_Notify, MUIA_Pressed, FALSE,
        keep, 3, MUIM_CallHook, &change_hook, 2);

    DoMethod(toggle, MUIM_Notify, MUIA_Pressed, FALSE,
        toggle, 3, MUIM_CallHook, &change_hook, 3);

    DoMethod(perform, MUIM_Notify, MUIA_Pressed, FALSE,
        app, 2, MUIM_Application_ReturnID, ID_PERFORM);

    DoMethod(skipall, MUIM_Notify, MUIA_Pressed, FALSE,
        app, 2, MUIM_Application_ReturnID, ID_SKIPALL);

    DoMethod(nlist1, MUIM_Notify, MUIA_NList_TitleClick, MUIV_EveryTime,
        nlist1, 3, MUIM_CallHook, &title_click_hook, MUIV_TriggerValue);

    DoMethod(nlist1, MUIM_Notify, MUIA_NList_TitleClick, MUIV_EveryTime,
        nlist1, 3, MUIM_CallHook, &reverse_sort_hook, MUIV_TriggerValue);

    DoMethod(nlist1, MUIM_NList_UseImage, IMG, 0, 0);
    DoMethod(nlist1, MUIM_NList_UseImage, IMG2, 1, 0);
//    DoMethod(nlist1, MUIM_NList_UseImage, IMG3, 2, 0);

    return(app);
}

// updates transfer window for a given newsgroup

void setmui(struct NewsNode *nn)
{
    set(nlist1, MUIA_NList_Active, 0);

    sprintf(msg_transfer, (char *)msgTransfered, 0, nn->total_size / 1024, 0);
    sprintf(msg_message,  (char *)msgMessage, 0, nn->num_articles);
    sprintf(msg_bytes,    (char *)msgByte, 0, 0);
    sprintf(msg_ngname,   (char *)msgNgName, nn->ngname);
    sprintf(msg_remained, (char *)msgRemained, 0, 0);
    strcpy(msg_action, msgAction2);
    updategadgets(0);
}

void fail(char *str, int ret)
{
    struct NewsNode *nn;

    if(folders)
        free_folders_list(folders);

    FreeKillList();

    if(tr)
        delete_timer(tr);

    if(app)
        DoMethod(nlist1, MUIM_NList_UseImage, -1, 0);

    if(port)
        DeletePort(port);
    if(ARexxPort)
        DeleteMsgPort(ARexxPort);
    if(MiamiBase)
        CloseLibrary(MiamiBase);
    if(app)
        MUI_DisposeObject(app);
    if(oldcurrentdir)
        CurrentDir(oldcurrentdir);
    if(currentdir)
        UnLock(currentdir);
    if(listpool)
        DeletePool(listpool);
    if(MUIMasterBase)
        CloseLibrary(MUIMasterBase);
    if(ReqToolsBase)
        CloseLibrary(ReqToolsBase);
    if(IntuitionBase)
        CloseLibrary(IntuitionBase);
    if(LocaleBase)
        CloseLibrary(LocaleBase);
    if(RexxSysBase)
        CloseLibrary(RexxSysBase);
    if(SocketBase)
        CloseLibrary(SocketBase);
    if(str)
    {
        puts(str);
        exit(20);
    }
    exit(ret);
}

