/*
**   YAM2NN - Usenet access for YAM p7 and newer
**   Copyright (C) 1999 Karol Bryd <kbryd@femina.com.pl>
**
**   This program is free software; you can redistribute it and/or
**   modify it under the terms of the GNU General Public License
**   as published by the Free Software Foundation; either version 2
**   of the License, or (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __GNUC__
#include <proto/socket.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include <time.h>
#include <ctype.h>


#define TRUE 1
#define FALSE 0

extern char fbuf[];


// networking code taken for AmiTCP SDK

int
getSockAddr(const char *     host,
        int          port,
        struct sockaddr_in * addr)
{
  struct hostent * remote;

  if ((remote = gethostbyname(host)) != NULL)
    memcpy(&addr->sin_addr, remote->h_addr, sizeof addr->sin_addr);
  else if ((addr->sin_addr.s_addr = inet_addr(host)) == (unsigned long)-1) {
    return FALSE;
  }

  addr->sin_port = htons(port);
  addr->sin_family = AF_INET;

  return TRUE;
}

const int ONE = 1;

int inetconn (const struct sockaddr_in * addr)
{
  int sd;

  if ((sd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    return -1;
  }

  setsockopt(sd, SOL_SOCKET, SO_KEEPALIVE, &ONE, sizeof ONE);

  if (connect(sd, (struct sockaddr *)addr, sizeof (struct sockaddr_in)) < 0) {
    close(sd);
    return -1;
  }

  return sd;
}


int do_connect(char * host, int port)
{
  struct sockaddr_in
    addr = { 0 }; /* implicit bzero() here when compiled w/ gcc */

  if (getSockAddr(host, port, &addr) == FALSE) {
    Printf("Cannot resolve host address\n");
    return -1;
  }

  return inetconn(&addr);
}


int ngets(char *p, int fd)
{
    int n;
    char *q;

    *p = 0;
    while(1)
    {
        q=strchr(fbuf, '\n');
        if(q)
        {
            n = q - fbuf + 1;
            strncpy(p, fbuf, n);
            p += n;
            strcpy(fbuf, q+1);
            break;
        }
        n = strlen(fbuf);
        strcpy(p, fbuf);
        p += n;
        n = recv(fd, fbuf, 1024, 0);
        if(n < 0)
            return(-1);
        fbuf[n] = 0;
    }
    *p = 0;
    return 0;
}

int nwrite(int socket, char *s)
{
    int len=strlen(s);
    send(socket, s, len, 0);
    return(len);
}

