/*
$Log: YAM2NN.c $
Revision 1.4  1999/05/01 20:56:09  kbryd
Rewritten GetNews() function, added FetchMessage(), fixed some
problems with CPS calculating. Added some alpha code for server
change detection, altough it doesn't work yet...

Revision 1.3  1999/04/14 15:47:56  kbryd
Done some test...please ignore.

*/

/*
**   YAM2NN - Usenet access for YAM p7 and newer
**   Copyright (C) 1999 Karol Bryd <kbryd@femina.com.pl>
**
**   This program is free software; you can redistribute it and/or
**   modify it under the terms of the GNU General Public License
**   as published by the Free Software Foundation; either version 2
**   of the License, or (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "Yam2NN.h"
#include "YAM2NN_kf.h"
#include "yam2nn_cat.c"
#include <sys/types.h>

#ifndef __GNUC__
#include <pragmas/socket_pragmas.h>
#endif

#define TAG_LOCAL 1
#define TAG_YAM   2

#define FILTER_SUBJECT 1
#define FILTER_ADDRESS 2

#define STOP 2
#define SKIP 3

#define ACTION_START       0
#define ACTION_STOP        1
#define ACTION_PRESELECT   2
#define ACTION_BEFORE_SEND 3
#define ACTION_AFTER_SEND  4
#define LAST_ACTION        5
//#define DEBUG

static char rcsid[] = "$Id: YAM2NN.c 1.4 1999/05/01 20:56:09 kbryd Exp kbryd $";

long __stack = 20000;

extern char *GetKey(void);

extern APTR app, window, transfer, message, bytes,
            action, ngname, remained, nlist1, keep,
            skip, perform, infotxt, preselectwindow;

Object *info = NULL;

struct ReqToolsBase   *ReqToolsBase = NULL;
struct IntuitionBase  *IntuitionBase = NULL;

#ifndef __GNUC__
struct Library        *RexxSysBase = NULL;
struct Library        *LocaleBase = NULL;
struct Library        *TimerBase;
#else
struct RxsLib         *RexxSysBase = NULL;
struct LocaleBase     *LocaleBase = NULL;
struct Device         *TimerBase;
#endif

struct Library        *MUIMasterBase = NULL;
struct Library        *MiamiBase = NULL;
struct Library        *SocketBase = NULL;

struct timerequest    *tr = NULL;

struct List           *newsgroupslist = NULL;
struct List           *folders;
struct MsgPort        *port, *ARexxPort;
struct NewsNode       *nn;

void                  *listpool;

BPTR oldcurrentdir = 0, currentdir = 0;

char *buf,
     *hostname,
     *nntphost,
     *tmp,
     *headerfile,
      fbuf[1024],
      userid[99],
      password[99],
      username[99],
      email[99],
      organization[99],
      *s_actions[LAST_ACTION];

char  msg_transfer[80],
      msg_action[80],
      msg_bytes[80],
      msg_message[80],
      msg_ngname[80],
      msg_remained[80],
      msg_preinfo[80];

char foldername[108], sentfolder[108];

int articles, skippedarticles, stopdownloading = FALSE, fetch_all = 0;
long sizetotal = 0, max = 60, bytesdownloaded = 0;
long sizedownloaded = 0, articlesdownloaded = 1;


double bps, oldbps, total_bps;
long    bps_cnt = 0;

FILE *debug;

// ripped from RKRM

void delete_timer(struct timerequest *tr)
{
    TimerBase = (struct Library *)(-1);

    if (tr != 0)
        CloseDevice((struct IORequest *)tr);
}

struct timerequest *create_timer(ULONG unit)
{
    struct timerequest *TimerIO;
    LONG error;

    TimerIO = AllocMem(sizeof(struct timerequest), MEMF_PUBLIC | MEMF_CLEAR);
    error = OpenDevice(TIMERNAME, unit, (struct IORequest *)TimerIO, 0L);
    if(error != 0)
        return(NULL);

    TimerBase = (struct Library *)TimerIO->tr_node.io_Device;

    return(TimerIO);
}

void Init(void)
{
    total_bps = oldbps = bps = 0.0;

    if (!(MUIMasterBase = OpenLibrary(MUIMASTER_NAME,MUIMASTER_VMIN)))
        fail((char *)msgFailedMUI, 0);

    if (!(IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library", 36)))
        fail("Failed to open intuition.library", 0);

    if (!(LocaleBase = OpenLibrary("locale.library", 37)))
        fail("Failed to open locale.library", 0);

    if (!(SocketBase = OpenLibrary("bsdsocket.library", 0)))
        fail("Failed to open bsdsocket.library", 0);

    if (!(RexxSysBase = OpenLibrary("rexxsyslib.library", 0)))
        fail("Failed to open rexxsyslib.library", 0);

    if(!(ReqToolsBase = (struct ReqToolsBase *)OpenLibrary("reqtools.library", 36)))
        fail((char *)msgFailedReqtools, 0);

    #ifdef NOMIAMI
    MiamiBase = OpenLibrary("miami.library", 10);
    #endif

    tr = create_timer(UNIT_MICROHZ);

    ARexxPort = CreateMsgPort();
    if(!ARexxPort)
        fail("Could not create a message port...", 0);

    if(!(listpool = LibCreatePool(MEMF_ANY|MEMF_CLEAR, 4096, 4096)))
        fail((char *)msgFailedPool, 0);

    if(!(buf = LibAllocPooled(listpool, 4096)))
        fail((char *)msgFailedMemory, 0);

    if(!(hostname = LibAllocPooled(listpool, 100)))
        fail((char *)msgFailedMemory, 0);

    if(!(nntphost = LibAllocPooled(listpool, 100)))
        fail((char *)msgFailedMemory, 0);

    if(!(tmp = LibAllocPooled(listpool, 1024)))
        fail((char *)msgFailedMemory, 0);

    if(!(headerfile = LibAllocPooled(listpool, 256)))
        fail((char *)msgFailedMemory, 0);

    sprintf(msg_transfer, (char *)msgTransfered, 0L, 0L, 0L);
    sprintf(msg_message,  (char *)msgMessage, 0, 0);
    sprintf(msg_bytes,    (char *)msgByte, 0, 0);
    sprintf(msg_ngname,   (char *)msgNgName, msgNone);
    sprintf(msg_remained, (char *)msgRemained, 0, 0);
    strcpy(msg_action, msgAction1);

    CreateKillList();
}

int __inline DisplayRequester(char *body, char *but)
{
    return((int)rtEZRequestTags(body, but ? but : "_Ok", NULL, NULL, RTEZ_Flags, EZREQF_CENTERTEXT, RT_Underscore, '_', TAG_END));
}

// performs action (currently only executes single command, but in future
// it couldbe rewritten to a more useful form - ARexx scripts and so on...

void PerformAction(int number)
{
    Execute(s_actions[number + 1], NULL, Output());
}

// adds a newline to a popup listview in transfer window

void SetInfo(char *s, char *s1, int type)
{
    char infotxt[255];

    if(s1)
    {
        if(type)
            sprintf(infotxt, "\033b%s %s", s, s1);
        else
            sprintf(infotxt, "\033n%s %s", s, s1);
    }
    else
    {
        if(type)
            sprintf(infotxt, "\033b%s", s);
        else
            sprintf(infotxt, "\033n%s", s);
    }
    DoMethod(info, MUIM_NList_InsertSingle, infotxt, MUIV_NList_Insert_Top);
}

//% GetFolderName

// gets a folder name from .fconfig file
int GetFolderName(char *folder, char *path)
{
    char fconfig[255];
    BPTR fh;

#ifdef DEBUG
    fprintf(debug, "GET folder name: %s\n", folder, path);
#endif

    strcpy(fconfig, path);
    AddPart(fconfig, ".fconfig", 108);
    fh = Open(fconfig, MODE_OLDFILE);
#ifdef DEBUG
    fprintf(debug, "opening folder name %s\n", fconfig);
#endif

    if(!fh)
        return(FALSE);
    while(FGets(fh, fconfig, 108))
    {
        if(strnicmp("name", fconfig, 4)==0)
        {
            int a = 0, b = 0;

            while((fconfig[a++] != '=') && (a < 108)) ;

            if(a < 107)
            {
                a++;
                while(isspace(fconfig[a++])) ;

                a--;
                while(fconfig[a] != 10)
                    folder[b++] = fconfig[a++];
            }

            folder[b] = 0;
#ifdef DEBUG
            fputs(folder, debug);
#endif
            break;
        }
    }
    Close(fh);
    return(TRUE);
}
//%

// this code was written by Christian Hattemer <Chris@heaven.riednet.wh.tu-darmstadt.de>

ULONG SendRexxCommand(STRPTR Port, STRPTR Cmd, struct MsgPort *ReplyPort, STRPTR Result)
{
   ULONG Error;

   struct MsgPort *RexxPort;

   *Result = '\0';

   Forbid();

   if (RexxPort = FindPort(Port))
   {
      struct RexxMsg *rexxMsg, *Answer;

      if (rexxMsg = CreateRexxMsg(ReplyPort, NULL, NULL))
      {
         if (rexxMsg->rm_Args[0] = CreateArgstring(Cmd, strlen(Cmd)))
         {
            rexxMsg->rm_Action = RXCOMM | RXFF_RESULT;

            PutMsg(RexxPort, &rexxMsg->rm_Node);

            do
            {
               WaitPort(ReplyPort);
               Answer = (struct RexxMsg *)GetMsg(ReplyPort);
            } while (Answer == NULL);

            Permit();

            if ((Error = Answer->rm_Result1) == RC_OK)
            {
               if (Answer->rm_Result2)
               {
                  strcpy(Result, (STRPTR)Answer->rm_Result2);
                  DeleteArgstring((UBYTE *)Answer->rm_Result2);
               }
            }

            DeleteArgstring((UBYTE *)ARG0(Answer));
            DeleteRexxMsg(Answer);

            return Error;
         }
         else
         {
            DeleteRexxMsg(rexxMsg);
         }
      }
   }

   Permit();

   return RC_FATAL;
}

/*
int GetPathP6(int foldernum, char *folder)
{
    sprintf(buf, "SETFOLDER %d", foldernum);
    SendRexxCommand("YAM", buf, ARexxPort, buf);

    sprintf(buf, "FOLDERINFO %d", foldernum);
    SendRexxCommand("YAM", buf, ARexxPort, tmp);

    sscanf(buf, "%*s %*s %s", folder);

    return(TRUE);
}
*/

//% GetValidName

// gets valid name from YAM, there are two modes:
// TAG_YAM - get a valid name directly from YAM - safe but VERY slow
// TAG_LOCAL - creates valid name without YAM's help, which is MUCH
// faster

int GetValidFileName(char *name, char *folder, u_char type, long *a1, long *a2)
{
    static char local_copy[255], local_path[255];
    long a, b;
    BPTR fh = 0;
    int n;

    if(type == TAG_YAM)
    {
#ifdef DEBUG
        fprintf(debug, "TAG_YAM ");
#endif
        sprintf(buf, "NEWMAILFILE \"%s\"", folder);
        SendRexxCommand("YAM", buf, ARexxPort, name);

        n = strlen(name);
        while((name[n] != '/') && (n > 0))
            n--;

        n++;
        bzero(local_copy, sizeof(local_copy));
        bzero(local_path, sizeof(local_path));

        strcpy(local_copy, &name[n]);
        strncpy(local_path, name, n);

        // YAM's message name looks like this: '07233.023'
        // first part is number of days since 1.1.1978,
        // the second part is a running number for that day
        // I simple remeber these two numbers
        // and in TAG_LOCAL increment second part by one

        sscanf(local_copy, "%d.%d", a1, a2);
    }
    else
    {
        BOOL ok = FALSE;

#ifdef DEBUG
        fputs("TAG_LOCAL\n", debug);
#endif
        // repeat until we find an unused name
        while(!ok)
        {
            // create name
            sscanf(local_copy, "%d.%d", &a, &b);
            b++;
            sprintf(name, "%s%05d.%03d", local_path, a, b);

            // and check whether it is not used already
            fh = Lock(name, ACCESS_READ);
            if(fh)
                UnLock(fh);
            else
                ok = TRUE;

            sprintf(local_copy, "%05d.%03d", a, b);
            *a1 = a;
            *a2 = b;
        }
    }
    return(TRUE);
}
//%

// sends authorization to the server - I think that it doesn't work
void SendAuth(int sd)
{
    sprintf(buf, "AUTHINFO USER %s\r\n", userid);
    nwrite(sd, buf);

    if(ngets(buf, sd) < 2)
        return;
    if(atol(buf) == 350)
    {
        sprintf(buf, "AUTHINFO PASSWORD %s\r\n", password);
        nwrite(sd, buf);
    }
}

void CheckAuth(int sd)
{
    if(atol(buf) == 450)
        SendAuth(sd);
}

// like strstr but not case sensitive

char *stristr(char *buf, char *str)
{
    register int len = strlen(buf);
    register int len2 = strlen(str);
    register int a;

    for(a = 0; a <= len - len2; a++)
        if(strnicmp(&buf[a], str, len2) == 0)
            return(&buf[a]);
    return(0);
}

// checks for error in result string received from server

int IsError(char *buf)
{
    int result;

    sscanf(buf, "%d", &result);
    if(result >= 200 && result < 300)
        return(1);
    else if(result >=400)
        return(0);

    return(1);
}

// strips '\r' from end of line

void StripRC(char *in)
{
    int len;

    if(!in)
        return;

    len = strlen(in);

    if(in[len - 2] == '\r')
    {
        in[len - 2] = '\n';
        in[len - 1] = 0;
    }
}

// adds '@news' to every newsgroup name from a 'Newsgroups' field
// for example: alt.test, pl.test will give alt.test@news, pl.test@news
char *ConvertTo(char *in)
{
    char *next_token = in;
    char ngname[80];
    static char out_buf[255];

    strcpy(out_buf, "");
    while(1)
    {
        next_token = stptok(next_token, ngname, sizeof(ngname), ",");

        if(!ngname)
            break;

        strcat(out_buf, ngname);

        if(*next_token == '\0')
        {
            strcat(out_buf, "@news");
            break;
        }
        else
            strcat(out_buf, "@news, ");

        next_token = stpblk(++next_token);
    }
    strcat(out_buf, "\n");
    return(out_buf);
}

// like IsError() but displays requester with error string

int IsError2(char *buf)
{
    int result;

    sscanf(buf, "%d", &result);
    if(result >= 200 && result < 300)
        return(1);
    else if(result >=400)
    {
        StripRC(buf);
        DisplayRequester(buf, NULL);
        SetInfo(buf, NULL, TRUE);
        return(0);
    }
    return(1);
}

// saves header to a file in NNTP-Headers: directory

void SaveHeader(struct List *hdrlist, char *MsgID, char *folder)
{
    struct Node *hdrline;
    BPTR out;
    int n, i;
    char msgid_l[33];

    if(!hdrlist)
        return;

#ifdef DEBUG
    fprintf(debug, "Save header: %s to: %s\n", msgid, folder);
#endif
    strcpy(buf, "YAM:NNTP-Headers/");
    // add folder name
    AddPart(buf, folder, 60);

    i = n = 0;

    while(MsgID[n] != '>')
    {
        if(i > 30)
            break;

        msgid_l[i++] = MsgID[n++];
    }

    msgid_l[i] = 0;
    msgid_l[0] = 'p';
    msgid_l[30] = 0;

    AddPart(buf, msgid_l, 108);
    out = Open(buf, MODE_NEWFILE);

    if(!out)
        return;

    for(hdrline = hdrlist->lh_Head; hdrline->ln_Succ; hdrline = hdrline->ln_Succ)
    {
        // if a new line then exit
        if((hdrline->ln_Name[0] == '\r') || (hdrline->ln_Name[0] == '\n'))
            break;

        Write(out, hdrline->ln_Name, strlen(hdrline->ln_Name));
    }
    Close(out);
}

void ArticleInfo(struct timeval *end, struct NewsNode *nn, struct Article *art, long n)
{
    double t;
    long total, m, s;

    t = end->tv_secs + (end->tv_micro / 1000000.0);

    if(t)
        bps = n / t;
    else
        bps = 0;

    total_bps += bps;
    bps_cnt++;

    bps = total_bps / bps_cnt;

    if(bps)
        total = (long)((nn->total_size - nn->size_downloaded) / bps);
    else
        total = 0;

    m = total / 60;
    s = total % 60;

    sprintf(msg_remained, (char *)msgRemained, m, s);
    sprintf(msg_bytes, (char *)msgByte, bytesdownloaded, art->Size);
    sprintf(msg_transfer, (char *)msgTransfered, nn->size_downloaded / 1024, nn->total_size / 1024, (long)bps);
    set(bytes, MUIA_Gauge_Current, bytesdownloaded);
    updategadgets(1);

    bps = 0.0;
}

void FreeList(struct List *list)
{
    struct Node *node = list->lh_Head;
    struct Node *next;

    while(node->ln_Succ)
    {
        free(node->ln_Name);
        next = node->ln_Succ;
        FreeVec(node);
        node = next;
    }
    NewList(list);
}

struct NewsMessage *FetchMessage(struct NewsNode *nn, struct Article *art)
{
    struct NewsMessage *message;
    ULONG           sigs;
    long            downloaded;
    long            article_downloaded;
    long            refresh_count;

    if(!art->Status)
        return(NULL);

    message = AllocVec(sizeof(struct NewsMessage), MEMF_ANY | MEMF_CLEAR);
    if(!message)
        return(NULL);

    GetSysTime(&message->start);

    message->list = AllocVec(sizeof(struct List), MEMF_ANY | MEMF_CLEAR);
    NewList(message->list);

    downloaded = 0;
    article_downloaded = 0;
    refresh_count = 0;

    sprintf(buf, "ARTICLE %ld\r\n", art->Num);
    nwrite(nn->sd, buf);

    // get response
    if(ngets(buf, nn->sd) < 0)
        return(NULL);

    CheckAuth(nn->sd);

    SetInfo(buf, NULL, TRUE);

    set(bytes, MUIA_Gauge_Max, art->Size);
    // check for any errors
    if(!IsError2(buf))
        return(NULL);

    while(1)
    {
        struct Node *node;

        if(ngets(buf, nn->sd) < 0)
            break;

        if((buf[0] == '.') && (buf[1] == '\r') && (buf[2] == '\n'))
            break;

        if(strnicmp(buf, "Message-ID:", 11)==0)
        {
            int i = 0, n = 0;

            char *start = buf + 12;

            stptok(buf + 12, tmp, 1024, "\n");
            art->MessageID = strdup(tmp);
        }

        nn->size_downloaded += strlen(buf);

        DoMethod(app, MUIM_Application_Input, &sigs);

        if(stopdownloading)
            break;

        if(refresh_count > 300)
        {
            // refresh window every 300 downloaded bytes
            set(bytes, MUIA_Gauge_Current, nn->size_downloaded);

            sprintf(msg_bytes, (char *)msgByte,
                            article_downloaded,
                            art->Size);

            updategadgets(1);
            refresh_count = 0;
        }

        refresh_count += strlen(buf);

        node = AllocVec(sizeof(struct Node), MEMF_ANY);
        node->ln_Name = strdup(buf);
        AddTail(message->list, node);
    }

    GetSysTime(&message->end);
    return(message);
}


int GetNews(struct NewsNode *nn)
{
    struct timeval start, end;
    struct Article *art;
    char foldername[255];
    BPTR artfh;
    long pos;
    ULONG sigs;

    if(!(GetFolderName(foldername, nn->path)))
        return(FALSE);

    // put info in window
    SetInfo((char *)msgDownloadingFrom, nn->ngname, FALSE);

    // update gadgets
    sprintf(msg_ngname, (char *)msgNgName, nn->ngname);

    set(message, MUIA_Gauge_Max, nn->num_articles);
    updategadgets(0);

    // set current group
    sprintf(buf, "GROUP %s\r\n", nn->ngname);
    SetInfo(buf, NULL, TRUE);

    nwrite(nn->sd, buf);

    if(ngets(buf, nn->sd) < 0)
        return(0);

    CheckAuth(nn->sd);

    SetInfo(buf, NULL, TRUE);

    // check for any errors
    if(!IsError2(buf))
        return(0);

    bps = 0.0;
    pos = 0;

    while(1)
    {
        struct NewsMessage *msg;
        struct Node    *msgline;

        nn->update = TRUE;

        // get informations about next article
        DoMethod(nlist1, MUIM_NList_GetEntry, pos, &art);
        if(!art)
            break;

        DoMethod(app, MUIM_Application_Input, &sigs);

        pos++;

        if(stopdownloading)
            break;

        msg = FetchMessage(nn, art);
        if(!msg)
            continue;

        set(message, MUIA_Gauge_Current, nn->art_downloaded);

        sprintf(msg_message, (char *)msgMessage,
                        nn->art_downloaded,
                        nn->num_articles);


        updategadgets(1);

        GetSysTime(&start);

        nn->art_downloaded++;

        msgline = msg->list->lh_Head;

        artfh = Open(art->FullName, MODE_NEWFILE);
        if(!artfh)
        {
            FreeList(msg->list);
            FreeVec(msg);
            continue;
        }

        // save header to NNTP-Headers: directory
        SaveHeader(msg->list, art->MessageID, foldername);

        // save rest of message
        while(msgline->ln_Succ)
        {
            char *buff = msgline->ln_Name;
            BOOL header = TRUE, skipread = FALSE;

            if(buff[0] == '\r' && buff[1] == '\n')
                header = FALSE;

            StripRC(buff);

            if(header)
            {
                if(strnicmp(buff, "Newsgroups:", 11) == 0)
                {
                    char *new_to, *ln;

                    Write(artfh, buff, strlen(buff));
                    Write(artfh, "To: ", 4);

                    ln = strchr(buff + 12, '\n');
                    if(ln)
                        *ln = 0;

                    new_to = ConvertTo(buff + 12);

                    Write(artfh, new_to, strlen(new_to));
                    Write(artfh, "Reply-To: ", 10);
                    Write(artfh, new_to, strlen(new_to));
                    skipread = TRUE;
                }

                if(strnicmp(buff, "Reply-To:", 9) == 0)
                    skipread = TRUE;

                // simple workaround for a bug in YAM p5, p6, p7(?)
                // converts 'From: name (address)' to
                // 'From: name <address>'

                if(strnicmp(buff, "From:", 5) == 0)
                {
                    if(!strchr(buff, '<'))
                    {
                        char *adr, *name, *lf;
                        char newaddr[80];

                        name = strchr(buff + 6, '(') + 1;
                        lf = strchr(buff + 6, ')');
                        if(lf)
                            *lf = 0;
                        adr = strtok(buff + 6, " \n");

                        if(name - 1 == 0)
                            sprintf(newaddr, "From: %s\n", adr);
                        else
                            sprintf(newaddr, "From: %s <%s>\n", name, adr);
                        Write(artfh, newaddr, strlen(newaddr));
                        skipread = TRUE;
                        if(lf)
                            *lf = 10;
                    }
                }
            }

            if(!skipread)
                Write(artfh, buff, strlen(buff));

            msgline = msgline->ln_Succ;
        }

        Close(artfh);

        FreeList(msg->list);

        // calc how much time took downloading of the message
        SubTime(&msg->end, &msg->start);

        GetSysTime(&end);

        // calc how much time took saving the message to the disk
        SubTime(&end, &start);

        // calc how much time took downloading and saving
        AddTime(&end, &msg->end);

        // calc bps and update gadgets
        ArticleInfo(&end, nn, art, art->Size);
        FreeVec(msg);
    }

    // find number of last downloaded article (on server)
    if(nn->update)
    {
        long a = 0, last = nn->last;

        for(;; a++)
        {
            DoMethod(nlist1, MUIM_NList_GetEntry, a, &art);
            if(!art)
                break;

            if((art->Num > last) && art->Status)
            {
                last = art->Num;
                nn->last_pos = a;   // remeber position of the last article
            }
        }
        nn->last = last;    // remember number of the last article
        DoMethod(nlist1, MUIM_NList_GetEntry, nn->last_pos, &art);
        nn->last_id = strdup(art->MessageID);
    }
    else
        nn->last_id = strdup("");
}

int GetNewsWS(struct NewsNode *nn)
{
    struct timeval start, end;
    struct Article *art;
    struct Node    *msgline;
    struct NewsMessage *msg;

    long  pos;
    ULONG sigs;

    if(!(nn->mesg = AllocVec(sizeof(struct List), MEMF_ANY | MEMF_CLEAR)))
        return(FALSE);

    NewList(nn->mesg);

    // put info in window
    SetInfo((char *)msgDownloadingFrom, nn->ngname, FALSE);

    // update gadgets
    sprintf(msg_ngname, (char *)msgNgName, nn->ngname);

    set(message, MUIA_Gauge_Max, nn->num_articles);
    updategadgets(0);

    // set current group
    sprintf(buf, "GROUP %s\r\n", nn->ngname);
    SetInfo(buf, NULL, TRUE);

    nwrite(nn->sd, buf);

    if(ngets(buf, nn->sd) < 0)
        return(0);

    CheckAuth(nn->sd);

    SetInfo(buf, NULL, TRUE);

    // check for any errors
    if(!IsError2(buf))
        return(0);

    bps = 0.0;
    pos = 0;

    while(1)
    {
        nn->update = TRUE;

        // get informations about next article
        DoMethod(nlist1, MUIM_NList_GetEntry, pos, &art);
        if(!art)
            break;

        DoMethod(app, MUIM_Application_Input, &sigs);

        pos++;

        if(stopdownloading)
            break;

        msg = FetchMessage(nn, art);
        if(!msg)
            continue;

        msg->FullName = strdup(art->FullName);
        msg->MsgID    = strdup(art->MessageID);
        AddTail(nn->mesg, msg);

        set(message, MUIA_Gauge_Current, nn->art_downloaded);
        sprintf(msg_message, (char *)msgMessage,
                        nn->art_downloaded,
                        nn->num_articles);

        updategadgets(1);

        GetSysTime(&start);

        nn->art_downloaded++;

        // calc how much time took downloading of the message
        SubTime(&msg->end, &msg->start);

        GetSysTime(&end);

        // calc how much time took saving the message to the disk
        SubTime(&end, &start);

        // calc how much time took downloading and saving
        AddTime(&end, &msg->end);

        // calc bps and update gadgets
        ArticleInfo(&end, nn, art, art->Size);
    }

    // find number of last downloaded article (on server)
    if(nn->update)
    {
        long a = 0, last = nn->last;

        for(;; a++)
        {
            DoMethod(nlist1, MUIM_NList_GetEntry, a, &art);
            if(!art)
                break;

            if((art->Num > last) && art->Status)
            {
                last = art->Num;
                nn->last_pos = a;   // remeber position of the last article
            }
        }
        nn->last = last + 1;    // remember number of the last article
        DoMethod(nlist1, MUIM_NList_GetEntry, nn->last_pos, &art);
        nn->last_id = strdup(art->MessageID);
    }
    else
        nn->last_id = strdup("");
}

void SaveMessagesToDisk(struct NewsNode *nn)
{
    struct Node    *msgline;
    struct NewsMessage *msg;
    char   foldername[255];
    BPTR   artfh;
    ULONG  sigs, pos, saved_num = 0;

    if(!nn->mesg)
        return;

    setmui(nn);

    strcpy(msg_action, (char *)"\033cSaving messages\033n");

    // update gadgets
    sprintf(msg_ngname, (char *)msgNgName, nn->ngname);

    set(message, MUIA_Gauge_Max, nn->num_articles);

    updategadgets(0);

    if(!(GetFolderName(foldername, nn->path)))
        return;

    msg = (struct NewsMessage *)nn->mesg->lh_Head;
    set(message, MUIA_Gauge_Current, saved_num);

    while(msg->next)
    {
        struct NewsMessage *nextmsg;

        if(stopdownloading)
            break;

        msgline = msg->list->lh_Head;

        artfh = Open(msg->FullName, MODE_NEWFILE);
        if(!artfh)
        {
            FreeList(msg->list);
            FreeVec(msg);
            nextmsg = msg->next;
            Remove(msg);
            FreeVec(msg);
            msg = nextmsg;
            continue;
        }

        // save header to NNTP-Headers: directory
        SaveHeader(msg->list, msg->MsgID, foldername);

        // save rest of message
        while(msgline->ln_Succ)
        {
            char *buff = msgline->ln_Name;
            BOOL header = TRUE, skipread = FALSE;

            if(buff[0] == '\r' && buff[1] == '\n')
                header = FALSE;

            StripRC(buff);

            if(header)
            {
                if(strnicmp(buff, "Newsgroups:", 11) == 0)
                {
                    char *new_to, *ln;

                    FWrite(artfh, buff, strlen(buff), 1);
                    FWrite(artfh, "To: ", 4, 1);

                    ln = strchr(buff + 12, '\n');
                    if(ln)
                        *ln = 0;

                    new_to = ConvertTo(buff + 12);

                    FWrite(artfh, new_to, strlen(new_to), 1);
                    FWrite(artfh, "Reply-To: ", 10, 1);
                    FWrite(artfh, new_to, strlen(new_to), 1);
                    skipread = TRUE;
                }

                if(strnicmp(buff, "Reply-To:", 9) == 0)
                    skipread = TRUE;

                // simple workaround for a bug in YAM p5, p6, p7(?)
                // converts 'From: name (address)' to
                // 'From: name <address>'

                if(strnicmp(buff, "From:", 5) == 0)
                {
                    if(!strchr(buff, '<'))
                    {
                        char *adr, *name, *lf;
                        char newaddr[80];

                        name = strchr(buff + 6, '(') + 1;
                        lf = strchr(buff + 6, ')');
                        if(lf)
                            *lf = 0;
                        adr = strtok(buff + 6, " \n");

                        if(name - 1 == 0)
                            sprintf(newaddr, "From: %s\n", adr);
                        else
                            sprintf(newaddr, "From: %s <%s>\n", name, adr);
                        FWrite(artfh, newaddr, strlen(newaddr), 1);
                        skipread = TRUE;
                        if(lf)
                            *lf = 10;
                    }
                }
            }

            if(!skipread)
                FWrite(artfh, buff, strlen(buff), 1);


            msgline = msgline->ln_Succ;
        }

        Close(artfh);

        saved_num++;

        set(message, MUIA_Gauge_Current, saved_num);
        sprintf(msg_message, (char *)msgMessage,
                        saved_num,
                        nn->num_articles);

        updategadgets(1);

        FreeList(msg->list);
        nextmsg = msg->next;

        Remove(msg);

        free(msg->MsgID);
        free(msg->FullName);
        FreeVec(msg);

        msg = nextmsg;
    }

    if(stopdownloading)
    {
        struct NewsMessage *nextmsg;
        stopdownloading = 0;

        while(msg->next)
        {
            FreeList(msg->list);
            nextmsg = msg->next;

            Remove(msg);

            free(msg->MsgID);
            free(msg->FullName);
            FreeVec(msg);

            msg = nextmsg;
        }
    }
}

void __saveds abortdownload(void)
{
    stopdownloading = STOP;
}

// extracts email address from 'From:' field in a message

char *GetEMail(char *tmp)
{
    char *email;

    if(email = strchr(tmp, '<'))
        return strtok(email + 1, ">");
    else
        return strtok(tmp, "(");
}

int Preselect(void)
{
    int retval=0;

    PerformAction(ACTION_PRESELECT);

    sprintf(msg_preinfo, (char *)msgPreInfo, articles, skippedarticles);
    set(infotxt, MUIA_Text_Contents, msg_preinfo);

    set(preselectwindow, MUIA_Window_Open, TRUE);

    {
        ULONG sigs = 0, close;

        close = FALSE;
        while(!close)
        {
            switch (DoMethod(app, MUIM_Application_Input, &sigs))
            {
                case ID_PERFORM:
                    retval = TRUE;
                case ID_SKIPALL:
                case MUIV_Application_ReturnID_Quit:
                    close = TRUE;
                    break;
            }
            if (sigs && !close)
                sigs = Wait(sigs);
        }
    }
    set(preselectwindow, MUIA_Window_Open, FALSE);
    return(retval);
}

// counts how many messages we have to download and their total length

void set_ng_spec(struct NewsNode *nn)
{
    struct Article *art;
    long pos = 0;

    nn->num_articles    = 0;
    nn->art_downloaded  = 0;
    nn->total_size      = 0;
    nn->size_downloaded = 0;

    while(1)
    {
        DoMethod(nlist1, MUIM_NList_GetEntry, pos, &art);
        if(!art)
            break;

        if(art->Status)
        {
            nn->num_articles++;
            nn->total_size += art->Size;
        }

        pos++;
    }
}

//% ParseXOVER
void ParseXOVERInfo(char *xover, struct Article *a)
{
    char *token;

    // every field in XOVER response is separated by '\t'
    token = strtok(xover, "\t");
    strcpy(buf, token);
    a->Num = atol(buf);

    token = strtok(NULL, "\t");
    strcpy(buf, token);
    a->Subject = malloc(strlen(buf) + 1);
    strcpy(a->Subject, buf);

    token = strtok(NULL, "\t");
    strcpy(buf, token);
    a->From = malloc(strlen(buf) + 1);
    strcpy(a->From, buf);

    token = strtok(NULL, "\t");
    strcpy(buf, token);
    a->Date = malloc(strlen(buf) + 1);
    strcpy(a->Date, buf);

    token = strtok(NULL, "\t");
    strcpy(buf, token);
    a->Msg_ID = malloc(strlen(buf) + 1);
    strcpy(a->Msg_ID, buf);

    token = strtok(NULL, "\t");
    strcpy(buf, token);
    if(buf[0] == '<')
    {
        a->References = malloc(strlen(buf) + 1);
        strcpy(a->References, buf);
        token = strtok(NULL, "\t");
        strcpy(buf, token);
    }
    a->Size = atol(buf);

    token = strtok(NULL, "\t");
    strcpy(buf, token);
    a->Lines = atol(buf);

    token = strtok(NULL, "\t\n");
    if(token) // workaround for Leafnode mini server
    {
        strcpy(buf, token);
        a->Xref = malloc(strlen(buf) + 1);
        strcpy(a->Xref, buf);
    }
}
//%

#define HUGE_BUF 255

// get XOVER information from server

int GetXOVER(struct NewsNode *nn)
{
    long total_art, first_art, last_art;
    long atmost, retval=TRUE, sel, temp;
    char validname[HUGE_BUF];
    char foldername[HUGE_BUF];

    strcpy(msg_action, (char *)msgAction3);

    updategadgets(0);

    // send GROUP command
    sprintf(buf, "GROUP %s\r\n", nn->ngname);
    nwrite(nn->sd, buf);

    if(ngets(buf, nn->sd) < 0)
        return(0);

    CheckAuth(nn->sd);

    if(!IsError2(buf))
        return(0);

    // parse informations from server
    // total_art - total number of articles on server
    // first_art - number of first article available on server
    // last_art  - number of last rticle

    sscanf(buf, "%*ld %ld %ld %ld", &total_art, &first_art, &last_art);

    // if there is no new articles since last time, or total number
    // of articles is zero then return
    if((nn->last == last_art) || (total_art == 0))
    {
        strcpy(msg_action, (char *)msgAction4);
        updategadgets(0);
        return(0);
    }

    // 'atmost' is a maximum number of articles that we can download
    atmost = nn->maxmsg ? nn->maxmsg : max;

    // if we are downloading messages for the first time
    if(nn->last == 0)
    {
        nn->last = last_art - nn->initfetch;
        sprintf(buf, (char *)msgTooManyArticles, nn->initfetch, nn->last, last_art);
        SetInfo(buf, NULL, FALSE);
    }
    else if(nn->maxmsg > 0)
    {
        if((last_art - nn->last) > nn->maxmsg)
        {
            // if there is more articles than we can download
            sprintf(buf, (char *)msgServerInfo, nn->ngname, last_art-nn->last, nn->last, last_art);
            sprintf(tmp, (char *)msgDownloadLat, nn->maxmsg);

            // display a requester and ask what to do
            sel = DisplayRequester(buf, tmp);
            if(sel == 1)
                nn->last = last_art - nn->maxmsg;
            else if (sel == 0)
                return(0);
        }
    }

    // send command tothe server
    sprintf(buf, "XOVER %ld-%ld\r\n", nn->last, last_art);

    SetInfo(buf, NULL, TRUE);  // put response in list

    nwrite(nn->sd, buf);

    // get response

    if(ngets(buf, nn->sd) < 0)
        return(0);

    // and check it for en error
    CheckAuth(nn->sd);

    SetInfo(buf, NULL, TRUE);  // put response in list

    DoMethod(nlist1, MUIM_NList_Clear);

    skippedarticles = articles = 0;

    // get folder name (in which messages will be stored) for this newsgroup
    if(GetFolderName(foldername, nn->path))
        // and a first valid name for a letter (name can be for example "07233.001")
        if(!(GetValidFileName(validname, foldername, TAG_YAM, &temp, &atmost)))
            return(0);

    while(strcmp(buf, ".\r\n"))
    {
        static struct Article art;
        extern struct List *killlist;
        BOOL bigger = FALSE;
        int a, b;

        // get XOVER for one message
        if(ngets(buf, nn->sd) < 0)
            break;

        if(strcmp(buf, ".\r\n")==NULL)
            break;

        bzero(&art, sizeof(struct Article));

        // parse it
        ParseXOVERInfo(buf, &art);
 
        // if message's size is bigger than maximum then skip this message
        if(nn->maxlen)
            if(art.Size / 1024 > nn->maxlen)
                bigger = TRUE;

        art.Status = TRUE;

        // score message, if score < -9999 then skip message
        if(ScoreMessage(nn, &art) || bigger)
        {
            art.Status = FALSE;    // skip this message
            skippedarticles++;
        }

        // get valid name
        // validname - here a name will be stored (full with a path)
        // foldername - foldername where message will be saved
        // TAG_LOCAL - create valid name without using ARexx port

        if(!(GetValidFileName(validname, foldername, TAG_LOCAL, &a, &b)))
           break;

        sprintf(art.FileName, "%05d.%03d", a, b);
        strcpy(art.FullName, validname);

        // add the message to the list
        DoMethod(nlist1, MUIM_NList_InsertSingle, &art, MUIV_NList_Insert_Bottom);
        articles++;
    }

    if(articles)
    {
        // open preselect window if needed
        if(nn->preselect_type == ALWAYS)
            retval = Preselect();
        else if(nn->preselect_type == SKIPPED)
            {
                if(skippedarticles)
                    retval = Preselect();
                else
                    retval = TRUE;
            }
        else
            retval = TRUE;
    }
    else
        retval = 0;

    set_ng_spec(nn);

    return(retval);
}

// checks whether we are already connected to 'host'

int SearchNNList(char *host)
{
    struct NewsNode *nn = (struct NewsNode *)newsgroupslist->lh_Head;

#ifdef DEBUG
    fputs("search NNList\n", debug);
#endif
    while(nn->next)
    {
        if(stricmp(host, nn->host) == 0)
            return(nn->sd);
        nn = nn->next;
    }
    return(-2);
}

#define SINGLE_POST 1

// connects to hosts, there are two modes:
// - SINGLE_POST - we are posting a message - only one connection
//                 is needed
// - DOWNLOADING - we have to connect to all hosts that are in
//                 list

int NNTPConnect(int type)
{
    int sd;

    if(type == SINGLE_POST)
    {
        // connect
        sd = do_connect(nntphost, 119);
        if(sd < 0)
            return(0);

        if(ngets(buf, sd) < 0)
            return(0);

        // issue a 'hello' command
        nwrite(sd, "mode reader\r\n");

        if(ngets(buf, sd) < 0)
            return(0);

        // check response,
        if(atol(buf) == 201)
        {
            // we can't post - inform user
            DisplayRequester((char *)msgNoPosting, "Ok");
            return(0);
        }

        // check for authorizing
        if(atol(buf) == 205)
            SendAuth(sd);

        return(sd);
    }
    else
    {
        struct NewsNode *nn = (struct NewsNode *)newsgroupslist->lh_Head;

        while(nn->next)
        {
            nn->sd = -2;
            nn = nn->next;
        }

        nn = (struct NewsNode *)newsgroupslist->lh_Head;
        // repeat for all entries in a list
        while(nn->next)
        {

            if(nn->status == STATUS_INACTIVE)
            {
                nn = nn->next;
                continue;
            }
#ifdef DEBUG
            fprintf(debug, "connecting to %s\n", nn->host);
#endif
            // check whether we are already connected to the host
            if((sd = SearchNNList(nn->host)) != -2)
            {
                // if yes then copy descriptor and continue
                nn->sd = sd;
                nn = nn->next;
                continue;
            }
            else if(sd == -1)
            {
                nn = nn->next;
                continue;
            }
            else
            {
                // if not then connect there
                SetInfo((char *)msgConnectingTo, nn->host, FALSE);
                nn->sd = do_connect(nn->host, 119);
            }

            if(nn->sd < 0)
            {
#ifdef DEBUG
                fputs("failed\n", debug);
#endif
                SetInfo((char *)msgUnsuccessful, NULL, TRUE);
                nn->sd = -1;
                nn= nn->next;
                continue;
            }

            if(ngets(buf, nn->sd) < 0)
                continue;
#ifdef DEBUG
            fprintf(debug, "%s\n", buf);
#endif
            SetInfo(buf, NULL, TRUE);

            nwrite(nn->sd, "mode reader\r\n");

            if(ngets(buf, nn->sd) < 0)
                continue;

            if(atol(buf) == 205)
                SendAuth(nn->sd);
            if(!IsError2(buf))
            {
                close(nn->sd);
                nn->sd = -1;
            }

            nn = nn->next;
        }
    }
    return(TRUE);
}

// sends file with name 'filename' to a descriptor 'sd'
int PostFile(char *filename, int sd, int size)
{
    BPTR art;
    char *body, *lf, *cr;
    long bytes_sent = 0;

    // issue a POST command
    nwrite(sd, "POST\r\n");

    if(ngets(buf, sd) < 0)
        return(0);
    CheckAuth(sd);

    if(atoi(buf) != 340)
        return(0);

    body = AllocVec(512, MEMF_ANY);
    if(!body)
        return(0);

    // open file with message
    art = Open(filename, MODE_OLDFILE);
    if(!art)
    {
        FreeVec(body);
        return(0);
    }

    #ifdef DEBUG
        fprintf(debug, "post fh: %x\n", art);
    #endif

    // read one line
    while(FGets(art, body, 512))
    {
        // convert '\n' to '\r\n'
        lf = strchr(body, '\n');
        cr = strchr(body, '\r');
        if(lf && !cr)
        {
            *lf = '\r';
            *(lf + 1) = '\n';
            *(lf + 2) = 0;
        }
        // and finally send
        send(sd, body, strlen(body), 0);
        bytes_sent += strlen(body);
        set(bytes, MUIA_Gauge_Current, bytes_sent);

        sprintf(msg_bytes, (char *)msgByte, bytes_sent, size);
        set(bytes, MUIA_Gauge_InfoText, msgByte);
    }
    Close(art);

    // we have to end with '\r\n.\r\n'
    nwrite(sd, "\r\n.\r\n");

    ngets(buf, sd);

    #ifdef DEBUG
        fprintf(debug, "post sent\n");
    #endif

    FreeVec(body);

    if(!IsError2(buf))
        return(0);
    else
        return(1);
}

int FindOldHeader(char *in, char *out, char *header)
{
    int n = 0, i = 0;
    char *h;

    h = stristr(in, header);

    if(h)
    {
        while(h[n] != ':')
            n++;

        n += 2;

        while(1)
        {
            while(h[n] != 10)
                out[i++] = h[n++];

            if(h[n - 1] != ',')
                break;
            else
            {
                while(isspace(h[n++])) ;
                n--;
            }
        }

        out[i] = 0;
        return(TRUE);
    }
    return(FALSE);
}

// moves a message from OUTGOING to SENT folder
void MoveToSent(char *source_name)
{
    BPTR in;
    char full_name[32];
    char *name_with_path;
    char entry[108];
    int msg_num = 0, pos = 0;

    // get number of OUTGOING folder (it ought to be 1)
    pos = get_folder_pos(folders, OUTGOING);

    // get messages names and their numbers in OUTGOING folder
    sprintf(buf, "rx YAM:Rexx/CreateMsgDataBase.rexx %d", pos);

    if(!(Execute(buf, NULL, NULL)))
    {
        DisplayRequester((char *)msgCreateMsgDatabase, NULL);
        return;
    }

    in = Open("t:msg.db", MODE_OLDFILE);
    if(!in)
    {
        DisplayRequester((char *)msgNoDatabase, NULL);
        return;
    }

    // scan messages' database
    while(FGets(in, entry, sizeof(entry)))
    {
        char *ln;

        name_with_path = strchr(entry, ' ') + 1;

        ln = strchr(name_with_path, '\n');
        if(ln)
            *ln = 0;

        strcpy(full_name, FilePart(name_with_path));

        if(strcmp(full_name, source_name) == 0)
        {
            pos = get_folder_pos(folders, SENT);

            sprintf(buf, "SETMAIL %d", msg_num);
            SendRexxCommand("YAM", buf, ARexxPort, tmp);

            sprintf(buf, "MAILMOVE %d", pos);
            SendRexxCommand("YAM", buf, ARexxPort, tmp);
        }
        msg_num++;
    }

    Close(in);
}

#define MODE_SCAN 1   // scans outgoing folder, and returns number of
                      // messages that have to be posted
#define MODE_POST 2   // posts these messages

int GetNumOfPosts(int mode)
{
    struct FileInfoBlock __aligned fib;
    BPTR lock, fh;
    static int to_send;
    int num_of_sent = 1;
    int num_of_sent_bytes = 0;
    int sd;

    // lock outgoing directory
    lock = Lock(foldername, ACCESS_READ);
    if(!lock)
        return(0);

    // if we have to post then firstly connect to the server
    if(mode == MODE_POST)
    {
        #ifdef DEBUG
            fprintf(debug, "post connecting\n");
        #endif
        if((sd = NNTPConnect(SINGLE_POST)) < 0)
            return(0);

        set(message, MUIA_Gauge_Max, to_send);

        sprintf(msg_message,  (char *)msgMessage, 0, to_send);
        sprintf(msg_transfer, (char *)msgTransfered, 0, sizetotal / 1024, (long)bps);
        sprintf(msg_remained, (char *)msgRemained, 0, 0);

        updategadgets(1);
    }
    else
    {
        to_send = 0;
        sizetotal = 0;
    }

    // scan all files in outgoing folder except .fconfig and .index
    Examine(lock, &fib);

    while(ExNext(lock, &fib))
    {
        if(fib.fib_EntryType < -2)
        {
            if(stricmp(fib.fib_FileName, ".fconfig") && stricmp(fib.fib_FileName, ".index"))
            {
                char *letter;
                char field[80];
                char full_name[108];

                // compose a file name of a message with full path
                strcpy(full_name, foldername);
                AddPart(full_name, fib.fib_FileName, 108);
                fh = Open(full_name, MODE_OLDFILE);
                if(!fh)
                    continue;

                letter = AllocVec(fib.fib_Size + 1, MEMF_ANY | MEMF_CLEAR);
                if(!letter)
                    break;

                // read that message
                Read(fh, letter, fib.fib_Size);
                Close(fh);

                // and find 'To:' field
                FindOldHeader(letter, field, "\nTo:");

                FreeVec(letter);

                // if it has '@news' string in 'To:' header that it seems
                // to be our message
                if(stristr(field, "@news"))
                {
                    // if posting mode
                    if(mode == MODE_POST)
                    {
                        // recreate header for this message, and save it
                        // to T:
                        if(ChangeHeader(full_name))
                        {
                            struct timeval start, end;

                            GetSysTime(&start);

                            set(bytes, MUIA_Gauge_Max, fib.fib_Size);

                            // and finally send it
                            if(PostFile("t:usenetpost.tmp", sd, fib.fib_Size))
                            {
                                double t, bps;
                                long total, m, s;

                                GetSysTime(&end);
                                SubTime(&end, &start);

                                num_of_sent_bytes += fib.fib_Size;

                                t = end.tv_secs + (end.tv_micro / 1000000.0);

                                if(t)
                                    bps = fib.fib_Size / t;
                                else
                                    bps = 0.00001;

                                if(bps)
                                    total = (long)((sizetotal - num_of_sent_bytes) / bps);
                                else
                                    total = 0;

                                m = total / 60;
                                s = total % 60;

                                MoveToSent(fib.fib_FileName);
                                num_of_sent++;
                                DeleteFile(headerfile);
                                sprintf(msg_message,  (char *)msgMessage, num_of_sent, to_send);
                                sprintf(msg_transfer, (char *)msgTransfered, num_of_sent_bytes / 1024, sizetotal / 1024, (long)bps);
                                sprintf(msg_remained, (char *)msgRemained, m, s);

                                updategadgets(1);
                            }
                        }
                    }
                    else
                    {
                        to_send++;
                        sizetotal += fib.fib_Size;
                    }
                }
            }
        }
    }
    if(mode == MODE_POST)
    {
        close(sd);
        return(0);
    }
    else
        return(to_send);
}

char *ParseOneName(char *temp, char *ngname)
{
    char *ngname2;
    int m = 0, n = 0;

    if(ngname2 = strchr(temp, '<'))
    {
        ngname2++;

        while(ngname2[n] != '@')
            ngname[m++] = ngname2[n++];

        if(strncmp(&ngname2[n + 1], "news", 4))
            return(0);
    }
    else
    {
        while(isspace(temp[n++])) ;

        n--;

        while(temp[n] != '@')
            ngname[m++] = temp[n++];

        if(strncmp(&temp[n + 1], "news", 4))
            return(0);
    }
    ngname[m] = 0;
    return(&temp[n]);
}

void GetHeaderFileName(char *headername, char *msgid)
{
    struct NewsNode *nn = (struct NewsNode *)newsgroupslist->lh_Head;
    char foldername[255], *p;
    BPTR lock;

    while(nn->next)
    {
        strcpy(headerfile, "YAM:NNTP-Headers/");
        if(GetFolderName(foldername, nn->path))
            AddPart(headerfile, foldername, 108);

        msgid[0] = 'p';
        if(strlen(msgid) < 30)
        {
            p = strchr(msgid, '>');
            if(p)
                *p = 0;
        }
        else
            msgid[30] = 0;
        AddPart(headerfile, msgid, 108);
        if(lock = Lock(headerfile, ACCESS_READ))
        {
            UnLock(lock);
            break;
        }
        nn = nn->next;
    }
}

void GetDateTime(void)
{
    struct tm *p;
    time_t t;

    time(&t);
    p = localtime(&t);

    strftime(tmp, 50, "%d %b %Y %H:%M:%S", p);
}

void WriteHeader(char *b)
{
    char id[100];
    long x;

    sprintf(tmp, "From: %s <%s>\r\n", username, email);
    strcpy(b, tmp);


    time(&x);
    srand(x);

    sprintf(id, "Message-ID: <Yam2NN.AmigaOS.%X.%X@%s>\r\n", rand(), rand(), hostname);
    strcat(b, id);
    GetDateTime();
    sprintf(id, "Date: %s\r\n", tmp);
    strcat(b, id);
}

int ChangeHeader(char *file)
{
    BPTR old, lock, new;
    struct FileInfoBlock __aligned fib;
    char *oldmsg, *body;

    // get file info
    lock = Lock(file, ACCESS_READ);
    if(!lock)
        return(0);
    Examine(lock, &fib);
    UnLock(lock);

    // open file with letter
    if(!(old = Open(file, MODE_OLDFILE)))
    {
        UnLock(lock);
        return(0);
    }

    oldmsg = (char *)calloc(fib.fib_Size + 10, 1);

    // read it
    Read(old, oldmsg, fib.fib_Size);
    Close(old);

    // check whether it is a reply letter or a new letter
    FindOldHeader(oldmsg, tmp, "In-Reply-To:");
    tmp[30] = 0;
    GetHeaderFileName(headerfile, tmp);

    if(!(old = Open(headerfile, MODE_OLDFILE)))
    {
        // if it is a new letter

        char ngname[200];
        char *one_name;
        char tmp_buf[100];

        // then find out for who it is addressed
        FindOldHeader(oldmsg, tmp, "\nTo:");

        // if there is no '@news' string then it is not an Usenet letter
        if(!strstr(tmp, "@news"))
            return(0);

        // remove '@news' from each address
        one_name = tmp;
        strcpy(ngname, "");
        while(1)
        {
            one_name = ParseOneName(one_name, tmp_buf);
            strcat(ngname, tmp_buf);
            if(!one_name)
                break;
            one_name = strchr(one_name, ',');
            if(!one_name)
                break;

            one_name++;
            one_name = stpblk(one_name);
            strcat(ngname, ", ");
        }

        // open file where we will be storing a new letter
        new = Open("t:usenetpost.tmp", MODE_NEWFILE);

        // write 'From', 'Date' and 'Message-ID' field
        WriteHeader(buf);
        Write(new, buf, strlen(buf));

        // write newsgroups names

        sprintf(buf, "Newsgroups: %s\n", ngname);
        Write(new, buf, strlen(buf));

        sprintf(buf, "Reply-To: %s <%s>\n", username, email);
        Write(new, buf, strlen(buf));

        if(strlen(organization) > 2)
        {
            sprintf(buf, "Organization: %s\n", organization);
            Write(new, buf, strlen(buf));
        }

        if(FindOldHeader(oldmsg, tmp, "Subject:"))
            sprintf(buf, "Subject: %s\n", tmp);
        else
            sprintf(buf, "Subject: Undefinied subject!\n");

        Write(new, buf, strlen(buf));

        #ifdef DEBUG
            sprintf(buf, "X-Newsreader: YAM2NND 0.85 AmigaOS (" __DATE__ ") by Karol Bryd\n");
        #else
            sprintf(buf, "X-Newsreader: YAM2NN 0.85 AmigaOS (" __DATE__ ") by Karol Bryd\n");
        #endif

        Write(new, buf, strlen(buf));

        if(FindOldHeader(oldmsg, tmp, "In-Reply-To:"))
        {
            sprintf(buf, "References: %s\n", tmp);
            Write(new, buf, strlen(buf));
        }

        if(FindOldHeader(oldmsg, tmp, "MIME-Version:"))
        {
            sprintf(buf, "MIME-Version: %s\n", tmp);
            Write(new, buf, strlen(buf));
        }

        if(FindOldHeader(oldmsg, tmp, "Content-Type:"))
        {
            sprintf(buf, "Content-Type: %s\n", tmp);
            Write(new, buf, strlen(buf));
        }

        if(FindOldHeader(oldmsg, tmp, "Content-Transfer-Encoding:"))
        {
            sprintf(buf, "Content-Transfer-Encoding: %s\n", tmp);
            Write(new, buf, strlen(buf));
        }

        body = stristr(oldmsg, "\n\n")+1;
        Write(new, body, strlen(body)-1);
        Close(new);
    }
    else
    {
        // if it is a reply

        if(FindOldHeader(oldmsg, tmp, "\nTo:"))
        {
            if(!strstr(tmp, "@news"))
            {
                Close(old);
                return(0);
            }
        }
        // read header from NNTP-Headers directory
        Read(old, oldmsg, fib.fib_Size);
        Close(old);

        new = Open("t:usenetpost.tmp", MODE_NEWFILE);

        WriteHeader(buf);
        Write(new, buf, strlen(buf));

        FindOldHeader(oldmsg, tmp, "Newsgroups:");

        sprintf(buf, "Newsgroups: %s\n", tmp);
        Write(new, buf, strlen(buf));

        sprintf(buf, "Reply-To: %s <%s>\n", username, email);
        Write(new, buf, strlen(buf));

        if(strlen(organization)>2)
        {
            sprintf(buf, "Organization: %s\n", organization);
            Write(new, buf, strlen(buf));
        }

        // copy references from old post and add our Message-ID
        if(FindOldHeader(oldmsg, buf, "References:"))
        {
            char *cr;

            Write(new, "References: ", 12);
            cr = strchr(buf, '\r');
            if(cr)
                *cr = 0;
            Write(new, buf, strlen(buf));
            Write(new, "  ", 1);
        }
        else
            Write(new, "References: ", 12);

        FindOldHeader(oldmsg, tmp, "Message-ID:");
        strcpy(buf, tmp);
        Write(new, buf, strlen(buf));

        old = Open(file, MODE_OLDFILE);

        oldmsg[Read(old, oldmsg, fib.fib_Size)] = 0;
        Close(old);

        FindOldHeader(oldmsg, tmp, "Subject:");
        if(tmp[0] == 'R' && tmp[1] == 'e' && tmp[2] == ':')
            sprintf(buf, "\nSubject: %s\n", tmp);
        else
            sprintf(buf, "\nSubject: Re: %s\n", tmp);
        Write(new, buf, strlen(buf));

        #ifdef DEBUG
            sprintf(buf, "X-Newsreader: YAM2NND 0.85 AmigaOS (" __DATE__ ") by Karol Bryd\n");
        #else
            sprintf(buf, "X-Newsreader: YAM2NN 0.85 AmigaOS (" __DATE__ ") by Karol Bryd\n");
        #endif

        Write(new, buf, strlen(buf));

        if(FindOldHeader(oldmsg, tmp, "MIME-Version:"))
        {
            sprintf(buf, "MIME-Version: %s\n", tmp);
            Write(new, buf, strlen(buf));
        }

        if(FindOldHeader(oldmsg, tmp, "Content-Type:"))
        {
            sprintf(buf, "Content-Type: %s\n", tmp);
            Write(new, buf, strlen(buf));
        }

        if(FindOldHeader(oldmsg, tmp, "Content-Transfer-Encoding:"))
        {
            sprintf(buf, "Content-Transfer-Encoding: %s\n", tmp);
            Write(new, buf, strlen(buf));
        }

        body = stristr(oldmsg, "\n\n")+1;
        Write(new, body, strlen(body)-1);

        Close(new);
        free(oldmsg);
    }
    return(1);
}

// gets paths for SENT and OUTGOING folders

void get_folders(void)
{
    char *xx;

    xx = get_folder_path(folders, SENT);
    if(xx)
        strcpy(sentfolder, xx);

    xx = get_folder_path(folders, OUTGOING);
    if(xx)
        strcpy(foldername, xx);
}

struct NewsNode *GetNode(char *ng)
{
    struct NewsNode *nn = (struct NewsNode *)newsgroupslist->lh_Head;

    while(nn)
    {
        if(stricmp(ng, nn->ngname) == 0)
            return(nn);

        nn = nn->next;
    }
    return(0);
}

int LoadConfig(void)
{
    BPTR fh;
    char *tmp;

    fh = Open("YAM:Yam2NN.config", MODE_OLDFILE);

    if(!fh)
        return(0);

    while(FGets(fh, buf, 200))
    {
        if(buf[0] == ';')
            continue;
        if(!(strnicmp(buf, "Username:", 9)))
        {
            tmp = strtok(buf + 10, "\n");
            tmp = tmp ? tmp : getenv("USERNAME");
            strncpy(username, tmp, 60);
            continue;
        }
        if(!(strnicmp(buf, "EMail:", 6)))
        {
            tmp = strtok(buf + 7, "\n");
            if(tmp)
                strncpy(email, tmp, 60);
            continue;
        }

        if(!(strnicmp(buf, "Userid:", 7)))
        {
            tmp = strtok(buf + 8, "\n");
            if(tmp)
                strncpy(userid, tmp, 60);
            continue;
        }

        if(!(strnicmp(buf, "Password:", 9)))
        {
            tmp = strtok(buf + 10, "\n");
            if(tmp)
                strncpy(password, tmp, 60);
            continue;
        }

        if(!(strnicmp(buf, "Organization:", 13)))
        {
            tmp = strtok(buf + 14, "\n");
            if(tmp)
                strncpy(organization, tmp, 60);
            continue;
        }

        if(!(strnicmp(buf, "Hostname:", 9)))
        {
            tmp = strtok(buf + 10, "\n");
            tmp = tmp ? tmp : getenv("HOSTNAME");
            strncpy(hostname, tmp, 60);
            continue;
        }

        if(!(strnicmp(buf, "Postname:", 9)))
        {
            tmp = strtok(buf + 10, "\n");
            if(tmp)
                strncpy(nntphost, tmp, 60);
            continue;
        }

        if(!(strnicmp(buf, "Action", 6)))
        {
            int action_number = 0;

            action_number = buf[6] - '0';

            tmp = strtok(buf + 9, "\n");
            if(tmp)
                s_actions[action_number] = strdup(tmp);

            continue;
        }

        if(!(strnicmp(buf, "Fetch all:", 10)))
            fetch_all = atoi(&buf[11]);

        if(!(strnicmp(buf, "Newsgroups:", 11)))
        {
            struct NewsNode *newsnode;

            if(!newsgroupslist)
            {
                newsgroupslist = LibAllocPooled(listpool, sizeof(struct List));
                NewList(newsgroupslist);
            }

            newsnode = LibAllocPooled(listpool, sizeof(struct NewsNode));

            newsnode->update = FALSE;

            tmp = strtok(buf + 12, " ");
            if(!tmp)
                return(FALSE);

            newsnode->ngname = LibAllocPooled(listpool, strlen(tmp)+1);
            strcpy(newsnode->ngname, tmp);

            tmp = strtok(NULL, " ");
            if(!tmp)
                return(FALSE);
            newsnode->path = LibAllocPooled(listpool, strlen(tmp)+1);
            strcpy(newsnode->path, tmp);

            tmp = strtok(NULL, " ");
            if(!tmp)
                newsnode->status = STATUS_ACTIVE;
            else
            {
                if(strnicmp(tmp, "active", 6) == 0)
                    newsnode->status = STATUS_ACTIVE;
                else
                    newsnode->status = STATUS_INACTIVE;
            }

            tmp = strtok(NULL, " :\n");
            if(!tmp)
                return(FALSE);
            newsnode->host = LibAllocPooled(listpool, strlen(tmp) + 1);
            strcpy(newsnode->host, tmp);

            tmp = strtok(NULL, " \n");
            if(!tmp)
                return(FALSE);
            newsnode->port = atoi(tmp);


            FGets(fh, buf, 200);
            newsnode->maxlen = atol(&buf[13]);

            FGets(fh, buf, 200);
            newsnode->initfetch = atol(&buf[13]);

            FGets(fh, buf, 200);
            newsnode->maxmsg = atol(&buf[15]);

            FGets(fh, buf, 200);
            newsnode->flushthreshold = atoi(&buf[13]);
 
            FGets(fh, buf, 200);
            newsnode->preselect_type = atoi(&buf[16]);

            AddTail(newsgroupslist, newsnode);
        }
    }
    Close(fh);

    {
        struct NewsNode     *nn = (struct NewsNode *)newsgroupslist->lh_Head;
        struct SimpleConfig *mainsc;

        mainsc = cfg_open_simpleconfig("YAM2NN.last");
        if(mainsc)
        {
            while(nn->next)
            {
                nn->last = cfg_get_number_entry(mainsc, nn->ngname);
                strcpy(buf, nn->ngname);
                strcat(buf, "_id");
                tmp = cfg_get_string_entry(mainsc, buf);
                if(tmp)
                    nn->last_id = strdup(tmp);

                nn = nn->next;
            }

            cfg_free_simpleconfig(mainsc);
        }
        // find out current user's directory
        query_for_user();

        folders = open_folder_list();
        if(!folders)
        {
            folders = init_folder_list();
            if(build_folders_list(folders) < 0)
            {
                DisplayRequester((char *)msgNoYAMp7, (char *)msgExit);
                fail(0, 20);
            }

            save_folder_list(folders);
        }
        get_folders();
    }

    if((strlen(email) == 0) || (strlen(username) == 0))
        return(FALSE);
    return(TRUE);
}

void UpdateConfig(void)
{
    struct Article      *art;
    struct SimpleConfig *sc;
    struct NewsNode     *nn;
    char                *name, *id;
    long                 last;

    SetInfo((char *)msgUpdatingPrivate, NULL, FALSE);

    if(newsgroupslist)
        nn = (struct NewsNode *)newsgroupslist->lh_Head;

    sc = cfg_create_simpleconfig("YAM2NN.last");

    while(nn->next)
    {
        last = cfg_add_number_entry(sc, nn->ngname, nn->last);
        strcpy(buf, nn->ngname);
        strcat(buf, "_id");
        id = cfg_add_string_entry(sc, buf, nn->last_id?nn->last_id:"noone@nowhere");

        nn = nn->next;
    }

    cfg_save_simpleconfig(sc);
    cfg_free_simpleconfig(sc);
}

void FlushOldHeaders(void)
{
    BPTR lock, oldlock;
    struct FileInfoBlock __aligned fib;
    struct DateStamp today;
    struct NewsNode *nn = (struct NewsNode *)newsgroupslist->lh_Head;
    char foldername[255], tmp[255];

    DateStamp(&today);

#ifdef DEBUG
    fputs("flushing old hdrs\n", debug);
#endif

    lock = Lock("YAM:NNTP-Headers", ACCESS_READ);
    if(!lock)
        return;
    UnLock(lock);

    SetInfo((char *)msgFlushing, NULL, FALSE);

    while(nn->next)
    {
        if(nn->flushthreshold)
        {
            strcpy(foldername, "YAM:NNTP-Headers/");

            if(GetFolderName(tmp, nn->path))
                AddPart(foldername, tmp, 108);

            lock = Lock(foldername, ACCESS_READ);
            if(lock)
            {
                oldlock = CurrentDir(lock);

                Examine(lock, &fib);

                while(ExNext(lock, &fib))
                {
                    if(today.ds_Days - fib.fib_Date.ds_Days >= nn->flushthreshold)
                        DeleteFile(fib.fib_FileName);
                }

                CurrentDir(oldlock);
                UnLock(lock);
            }
        }
        nn = nn->next;
    }
    SetInfo((char *)msgDone, NULL, FALSE);
}

void UpdateFolders(void)
{
    struct NewsNode *nn=(struct NewsNode *)newsgroupslist->lh_Head;
    char foldername[255];
    BPTR artfh;

    SetInfo((char *)msgUpdatingFolders, NULL, FALSE);

#ifdef DEBUG
    fprintf(debug, "\nupdate folders\n");
#endif

    while(nn->next)
    {
        if(nn->update)
        {
#ifdef DEBUG
            fprintf(debug, "GetFolderName(%s)\n", nn->path);
#endif
            if(GetFolderName(foldername, nn->path))
            {
#ifdef DEBUG
            fprintf(debug, "update foldername = %s\n", foldername);
#endif
                sprintf(buf, "SETFOLDER \"%s\"", foldername);
                SendRexxCommand("YAM", buf, ARexxPort, tmp);
                SendRexxCommand("YAM", "MAILUPDATE", ARexxPort, tmp);
            }
        }
        nn = nn->next;
    }
//    sprintf(buf, "SETFOLDER %d", get_folder_pos(folders, INCOMING));
//    SendRexxCommand("YAM", buf, ARexxPort, tmp);

    SetInfo((char *)msgFoldersUpdated, NULL, FALSE);
}

void CreateFolders(void)
{
    struct NewsNode *nn=(struct NewsNode *)newsgroupslist->lh_Head;
    char foldername[255];
    BPTR folder;

    while(nn->next)
    {
#ifdef DEBUG
        fprintf(debug, "nn: %x ", nn);
#endif
        if(GetFolderName(foldername, nn->path))
        {
#ifdef DEBUG
            fprintf(debug, "\ncreating folder for: %s ", nn->path);
#endif
            strcpy(buf, "YAM:NNTP-Headers");
            AddPart(buf, foldername, 100);
            folder = Lock(buf, ACCESS_READ);

            if(!folder)
            {
                BPTR lock;

                lock = CreateDir(buf);
#ifdef DEBUG
                fprintf(debug, "%x\n", lock);
#endif
                if(lock)
                    UnLock(lock);
            }
            else
                UnLock(folder);
        }
        nn = nn->next;
    }
}

__saveds void SkipNewsgroup(void)
{
    stopdownloading = SKIP;
}

// open an info window (it's opened by popup button in the main window)

__saveds void InfoWindow(void)
{
    static int open;

    extern APTR root_group;

    if(open)
    {
        DoMethod(root_group, MUIM_Group_InitChange);
        DoMethod(root_group, OM_REMMEMBER, info);
        DoMethod(root_group, MUIM_Group_ExitChange);
        open = FALSE;
        return;
    }

    DoMethod(root_group, MUIM_Group_InitChange);
    DoMethod(root_group, OM_ADDMEMBER, info);

    DoMethod(root_group, MUIM_Group_ExitChange);
    open = TRUE;
}

// check if user changed server
// the alghoritm is following:
// get Message-ID of last downloaded message and comapre it to our
// Message-ID, that was taken last time when we were downloading messages

int CheckServerChange(struct NewsNode *nn)
{
    char *msgid;

    if(nn->last_id)
    {
        if(strlen(nn->last_id) == 0)
            return(0);
    }
    else
        return(0);
    // get Message-ID field

    sprintf(buf, "GROUP %s\r\n", nn->ngname);
    nwrite(nn->sd, buf);

    // get response
    if(ngets(buf, nn->sd) < 0)
        return(0);

    CheckAuth(nn->sd);

    if(!IsError2(buf))
        return(0);

    sprintf(buf, "XHDR Message-ID %ld\r\n", nn->last - 1);
    nwrite(nn->sd, buf);

    // get response
    if(ngets(buf, nn->sd) < 0)
        return(0);

    if(strncmp(buf, ".\r\n", 3) == 0)
        return(0);

    CheckAuth(nn->sd);

    if(atol(buf) == 221)
    {
        if(ngets(buf, nn->sd) < 0)
            return(0);

        if(strncmp(buf, ".\r\n", 3) == 0)
            return(0);

        Printf("%s\n", buf);

        msgid = strchr(buf, '<');

        *(strchr(msgid, '\r')) = 0;

        if(strcmp(nn->last_id, msgid) == 0)
        {
            // the server hasn't changed

            return(0);
        }
        else
        {
            char *name;

            sprintf(buf, "XHDR Xref %s\r\n", nn->last_id);
            nwrite(nn->sd, buf);

            // get response
            if(ngets(buf, nn->sd) < 0)
                return(0);

            CheckAuth(nn->sd);

            if(atol(buf) == 221)
            {
                if(ngets(buf, nn->sd) < 0)
                    return(0);

                Printf("%s\n", buf);

                name = strstr(buf, nn->ngname);
                if(name)
                {
                    char *last_number;

                    last_number = strchr(name, ':');
                    if(last_number)
                    {
                        last_number++;
                        nn->last = atol(last_number);
                        return(1);
                    }
                }
            }
        }
    }
}

int main(int argc, char **argv)
{
    struct NewsNode *nn;
    struct Article a;
    char *decoded;

    Init();

    if(FindPort("Yam2NN.owl"))
    {
        DisplayRequester((char *)msgIsRunning, "Exit");
        fail(0,0);
    }
    else
        port = CreatePort("Yam2NN.owl", 0);

    currentdir = Lock("YAM:", ACCESS_READ);
    if(!currentdir)
        fail(0, 20);

    oldcurrentdir = CurrentDir(currentdir);

#ifdef DEBUG
    debug = fopen("YAM:YAM2NN.debug", "w");

    if(!debug)
    {
        DisplayRequester("Could not create file YAM:YAM2NN.debug", 0);
        fail(0, 20);
    }
#endif

#ifdef NOMIAMI
    // if Miami is running then check whether it is online
    if(MiamiBase)
    {
        if(!MiamiIsOnline("lo0"))
            // if not then exit
            fail(0, 0);
    }
#endif

    // load config
    foldername[0] = sentfolder[0] = 0;
    if(!(LoadConfig()))
    {
        DisplayRequester((char *)msgNoConfig, 0);
        fail(NULL, 20);
    }

    UpdateConfig();
    if(argc > 2)
    {
        // if we have to post articles
        int num_of_posts = 0;

        PerformAction(ACTION_BEFORE_SEND);

        // first check how of many
        num_of_posts = GetNumOfPosts(MODE_SCAN);

        if(num_of_posts > 0)
        {
            sprintf(msg_transfer, (char *)msgTransfered, 0, sizetotal / 1024, 0);
            sprintf(msg_message,  (char *)msgMessage, 0, num_of_posts);
            sprintf(msg_bytes,    (char *)msgByte, 0, 0);
            sprintf(msg_ngname,   (char *)msgNgName, " ----- ");
            sprintf(msg_remained, (char *)msgRemained, 0, 0);
            strcpy(msg_action, msgAction5);

            // open transfer window
            if(!(initmui()))
            {
                DisplayRequester((char *)msgProblems, 0);
                fail(NULL, 20);
            }

            set(window, MUIA_Window_Open, TRUE);

            updategadgets(0);

            // and send all messages
            (void)GetNumOfPosts(MODE_POST);

            set(window, MUIA_Window_Open, FALSE);

            PerformAction(ACTION_AFTER_SEND);
        }
    }
    else
    {
        // downloading of posts
        if(newsgroupslist)
        {
            PerformAction(ACTION_START);

            if(!(initmui()))
            {
                DisplayRequester((char *)msgProblems, 0);
                fail(NULL, 20);
            }

            set(window, MUIA_Window_Open, TRUE);

            // connect to a server
            NNTPConnect(2);

            // nn is a list of all newsgroups to download
            // look in Yam2NN.h for details
            nn = (struct NewsNode *)newsgroupslist->lh_Head;

            // create (if doesn't exist) directories
            CreateFolders();

            // and check and download messages from all groups
            while(nn->next && stopdownloading != STOP)
            {

                // if we are connected
                if(nn->sd >= 0)
                {
                    // if authorization needed send it
                    if(atol(buf) == 205)
                        SendAuth(nn->sd);

                    buf[0] = 0;
                    if(nn->status == STATUS_ACTIVE)
                    {
//                        CheckServerChange(nn);
                        // set transfer window values
                        setmui(nn);
                        // get XOVER info
                        if(GetXOVER(nn))
                        {
                            setmui(nn);
                            if(fetch_all)
                            {
                                // download all messages and store them in
                                // memory, WS - Without Save
                                GetNewsWS(nn);
                            }
                            else
                                // download messages in ordinary way
                                GetNews(nn);

                            // and store last message number
                            UpdateConfig();
                        }
                    }
                }
                stopdownloading = 0;
                nn = nn->next;
            }

            if(fetch_all)
            {
                // save messages down to the disk
                nn = (struct NewsNode *)newsgroupslist->lh_Head;
                while(nn->next)
                {
                    SaveMessagesToDisk(nn);
                    nn = nn->next;
                }
            }

            set(window, MUIA_Window_Open, FALSE);
            // update all folders
            UpdateFolders();
            // flush expired headers
            FlushOldHeaders();

            PerformAction(ACTION_STOP);
        }
        else
            DisplayRequester((char *)msgNoNewsgroups, 0);
    }
    fail(NULL, 0);
}

