/*
**   YAM2NN - Usenet access for YAM p7 and newer
**   Copyright (C) 1999 Karol Bryd <kbryd@femina.com.pl>
**
**   This program is free software; you can redistribute it and/or
**   modify it under the terms of the GNU General Public License
**   as published by the Free Software Foundation; either version 2
**   of the License, or (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "YAM2NNConfig.h"
#include "YAM2NNConfig_cat.h"

extern APTR app, window, lv2, lv3, server_list, username, org, email,
            hostname, postname, username, pass, userid, flushheaders,
            preselect_type_obj, fetchall;

extern char s_username[60], s_email[60], s_org[60], s_postname[60],
            s_hostname[60], s_max[10], s_userid[64], s_pass[64],
            s_startaction[], s_stopaction[], s_preselectaction[],
            s_beforesendaction[], s_aftersendaction[], fetch_all;

extern long preselect_type, abort_download;

int getconfig(void)
{
    BPTR fh;
    char *tmp, buf[200];

    if(!(fh = Open("YAM:Yam2NN.config", MODE_OLDFILE)))
    {
        GetVar("USERNAME", s_username, 99, GVF_GLOBAL_ONLY);
        GetVar("HOSTNAME", s_hostname, 99, GVF_GLOBAL_ONLY);
        strcpy(s_email, "change@me");
        strcpy(s_max, "40");
        strcpy(s_org, "Team AMIGA");
    }
    else
    {
        while(FGets(fh, buf, 200))
        {
            if(strlen(buf) < 2)
                break;
            if(buf[0] == ';' || buf[0] == '#')
                continue;

            if(!(strnicmp(buf, "Username:", 9)))
            {
                tmp = strtok(buf + 10, "\n");
                tmp = tmp ? tmp : getenv("USERNAME");
                strcpy(s_username, tmp);
            }
            if(!(strnicmp(buf, "EMail:", 6)))
            {
                tmp = strtok(buf + 7, "\n");
                if(tmp)
                    strcpy(s_email, tmp);
            }
            if(!(strnicmp(buf, "Organization:", 13)))
            {
                tmp = strtok(buf + 14, "\n");
                strcpy(s_org, tmp);
            }
            if(!(strnicmp(buf, "Password:", 9)))
            {
                tmp = strtok(buf + 10, "\n");
                if(tmp)
                    strcpy(s_pass, tmp);
            }
            if(!(strnicmp(buf, "UserID:", 7)))
            {
                tmp = strtok(buf + 8, "\n");
                if(tmp)
                    strcpy(s_userid, tmp);
            }
            if(!(strnicmp(buf, "Hostname:", 9)))
            {
                tmp = strtok(buf + 10, "\n");
                tmp = tmp ? tmp : getenv("HOSTNAME");
                strcpy(s_hostname, tmp);
            }
            if(!(strnicmp(buf, "Postname:", 9)))
            {
                tmp = strtok(buf + 10, "\n");
                if(tmp)
                    strcpy(s_postname, tmp);
            }

            if(!(strnicmp(buf, "Action1:", 8)))
            {
                tmp = strtok(buf + 9, "\n");
                if(tmp)
                    strcpy(s_startaction, tmp);
            }

            if(!(strnicmp(buf, "Action2:", 8)))
            {
                tmp = strtok(buf + 9, "\n");
                if(tmp)
                    strcpy(s_stopaction, tmp);
            }

            if(!(strnicmp(buf, "Action3:", 8)))
            {
                tmp = strtok(buf + 9, "\n");
                if(tmp)
                    strcpy(s_preselectaction, tmp);
            }
            if(!(strnicmp(buf, "Action4:", 8)))
            {
                tmp = strtok(buf + 9, "\n");
                if(tmp)
                    strcpy(s_beforesendaction, tmp);
            }
            if(!(strnicmp(buf, "Action5:", 8)))
            {
                tmp = strtok(buf + 9, "\n");
                if(tmp)
                    strcpy(s_aftersendaction, tmp);
            }

            if(!(strnicmp(buf, "Fetch all:", 10)))
                fetch_all = atol(buf + 11);

            if(!(strnicmp(buf, "Newsgroups:", 11)))
            {
                struct SelectedNG *ng;
                long pos;

                tmp = strtok(buf + 12, " ");

                DoMethod(selected_newsgroups, MUIM_NList_InsertSingle, tmp, MUIV_NList_Insert_Bottom);
                get(selected_newsgroups, MUIA_NList_Entries, &pos);
                DoMethod(selected_newsgroups, MUIM_NList_GetEntry, pos - 1, &ng);

                if(ng)
                {
                    tmp = strtok(NULL, " ");
                    if(!tmp)
                        return(FALSE);

                    strcpy(ng->ng_Path, tmp);

                    tmp = strtok(NULL, " \n");
                    if(!tmp)
                        ng->ng_Status = STATUS_ACTIVE;
                    else
                    {
                        if(strnicmp(tmp, "active", 6)==0)
                            ng->ng_Status = STATUS_ACTIVE;
                        else
                            ng->ng_Status = STATUS_INACTIVE;
                    }
                    tmp = strtok(NULL, " :");
                    strcpy(ng->ng_Server, tmp);
                    tmp = strtok(NULL, " \n");
                    ng->ng_Port = atoi(tmp);
                }

                FGets(fh, buf, 200);
                ng->ng_MaxLength = atol(&buf[13]);

                while(1)
                {
                    struct Node *node;

                    if(!(FGets(fh, buf, 200)))
                        break;

                    if(strnicmp(buf, "max. messages", 12) == 0)
                        ng->ng_MaxMessages = atol(&buf[15]);

                    if(strnicmp(buf, "init. fetch", 10) == 0)
                        ng->ng_InitFetch = atol(&buf[13]);

                    if(!(strnicmp(buf, "Flush after:", 12)))
                        ng->ng_FlushThreshold = atol(buf + 13);

                    if(!(strnicmp(buf, "Preselect type:", 15)))
                        ng->ng_PreselectType = atol(buf + 16);

                    if(strnicmp(buf, "\n", 1) == 0)
                        break;
                }
            }
        }
    }
    Close(fh);

    if(!(fh = Open("YAM:Yam2NN.hosts", MODE_OLDFILE)))
        DoMethod(server_list, MUIM_NList_InsertSingle, "news.tpnet.pl:119", MUIV_NList_Insert_Bottom);
    else
    {
        while(FGets(fh, buf, 200))
        {
            if(strlen(buf) < 2)
                break;
            if(buf[0] == ';' || buf[0] == '#')
                continue;

            DoMethod(server_list, MUIM_NList_InsertSingle, buf, MUIV_NList_Insert_Bottom);
        }
        Close(fh);
    }

    set(username, MUIA_String_Contents, s_username);
    set(email, MUIA_String_Contents, s_email);
    set(org, MUIA_String_Contents, s_org);
    set(hostname, MUIA_String_Contents, s_hostname);
    set(postname, MUIA_String_Contents, s_postname);
    set(pass, MUIA_String_Contents, s_pass);
    set(userid, MUIA_String_Contents, s_userid);

    set(fetchall, MUIA_Selected, fetch_all);

    set(start_action, MUIA_String_Contents, s_startaction);
    set(stop_action, MUIA_String_Contents, s_stopaction);
    set(before_send_action, MUIA_String_Contents, s_beforesendaction);
    set(after_send_action, MUIA_String_Contents, s_aftersendaction);
    set(preselect_action, MUIA_String_Contents, s_preselectaction);
}

SAVEDS void SaveConfig(void)
{
    long i, not_done = FALSE;
    BPTR fh;
    char *str, buf[300];
    struct SelectedNG *ng;

    fh = Open("YAM:yam2nn.config", MODE_NEWFILE);
    if(fh)
    {
        get(username, MUIA_String_Contents, &str);
        sprintf(buf, "username: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(email, MUIA_String_Contents, &str);
        sprintf(buf, "email: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(hostname, MUIA_String_Contents, &str);
        sprintf(buf, "hostname: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(postname, MUIA_String_Contents, &str);
        sprintf(buf, "postname: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(org, MUIA_String_Contents, &str);
        sprintf(buf, "organization: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(pass, MUIA_String_Contents, &str);
        sprintf(buf, "password: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(userid, MUIA_String_Contents, &str);
        sprintf(buf, "userid: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(fetchall, MUIA_Selected, &i);
        sprintf(buf, "fetch all: %ld\n", i);
        Write(fh, buf, strlen(buf));

        get(start_action, MUIA_String_Contents, &str);
        sprintf(buf, "action1: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(stop_action, MUIA_String_Contents, &str);
        sprintf(buf, "action2: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(preselect_action, MUIA_String_Contents, &str);
        sprintf(buf, "action3: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(before_send_action, MUIA_String_Contents, &str);
        sprintf(buf, "action4: %s\n", str);
        Write(fh, buf, strlen(buf));

        get(after_send_action, MUIA_String_Contents, &str);
        sprintf(buf, "action5: %s\n", str);
        Write(fh, buf, strlen(buf));

        for(i = 0;; i++)
        {
            DoMethod(selected_newsgroups, MUIM_NList_GetEntry, i, &ng);

            if(ng)
            {
                if(strlen(ng->ng_Name) > 2 && strlen(ng->ng_Path) > 2)
                {
                    struct Node *node;
                    char *lf;

                    lf = strchr(ng->ng_Path, 10);
                    if(lf)
                        *lf = 0;

                    sprintf(buf, "newsgroups: %s %s %s %s:%ld\n", ng->ng_Name, ng->ng_Path, ng->ng_Status==STATUS_ACTIVE?"active":"inactive", ng->ng_Server, ng->ng_Port);
                    Write(fh, buf, strlen(buf));

                    sprintf(buf, "max. length: %ld\n", ng->ng_MaxLength);
                    Write(fh, buf, strlen(buf));

                    sprintf(buf, "init. fetch: %ld\n", ng->ng_InitFetch);
                    Write(fh, buf, strlen(buf));

                    sprintf(buf, "max. messages: %ld\n", ng->ng_MaxMessages);
                    Write(fh, buf, strlen(buf));

                    sprintf(buf, "flush after: %ld\n", ng->ng_FlushThreshold);
                    Write(fh, buf, strlen(buf));

                    sprintf(buf, "preselect type: %ld\n", ng->ng_PreselectType);
                    Write(fh, buf, strlen(buf));

                    Write(fh, "\n", 1);
                }
                else
                {
                    sprintf(buf, msgErrorInConfiguration, ng->ng_Name);
                    if(MUI_Request(app, window, 0, NULL, "Ok|Abort", buf)!=1)
                    {
                        not_done = TRUE;
                        break;
                    }
                }
            }
            else
                break;
        }

        Close(fh);

        if(fh = Open("YAM:yam2nn.hosts", MODE_NEWFILE))
        {
            for(i = 0;; i++)
            {
                struct Server *server;

                DoMethod(server_list, MUIM_NList_GetEntry, i, &server);
                if(!server)
                    break;

                sprintf(buf, "%s:%ld\n", server->srv_Server, server->srv_Port);
                Write(fh, buf, strlen(buf));
            }
            Close(fh);
        }
    }
    else
        not_done = TRUE;

    if(!not_done)
        DoMethod(app, MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);
}

