#ifndef _YAM2NNCONFIG_H_
#define _YAM2NNCONFIG_H_

#include "compiler.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <exec/types.h>
#include <exec/lists.h>
#include <exec/nodes.h>
#include <exec/memory.h>
#include <dos/var.h>
#include <dos/dos.h>
#include <dos/datetime.h>

#include <libraries/asl.h>
#include <libraries/mui.h>
#include <libraries/reqtools.h>
#include <utility/tagitem.h>
#include <MUI/NList_mcc.h>
#include <MUI/NListview_mcc.h>
#include <MUI/Busy_mcc.h>

#include <sys/types.h>
#include <netinet/in.h>

// #include <inline/socket.h>

#include <proto/locale.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <proto/exec.h>
#include <proto/utility.h>
#include <proto/dos.h>

#ifdef __SASC
#include <proto/muimaster.h>
#include <proto/reqtools.h>
#endif

#include "killfile.h"

#define ID_PRI 1
#define ID_CANCEL 2

#ifdef NOT
#undef NOT
#define NOT 1
#endif

struct MyDate
{
    int y, m, d;
};

struct SelectedNG
{
    char        *ng_Name;
    char        *ng_Path;
    char        *ng_Server;
    int          ng_Port;
    long         ng_MaxLength;
    long         ng_MaxMessages;
    long         ng_InitFetch;
    long         ng_Status;
    long         ng_FlushThreshold;
    long         ng_PreselectType;
};

struct Server
{
    char *srv_Server;
    int   srv_Port;
};

#define ID_DONE 3

#define STATUS_ACTIVE  1
#define STATUS_INACTIVE 2

#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))

#define IMG \
     BodychunkObject,\
     MUIA_Bitmap_Width, SKIP_WIDTH,\
     MUIA_Bitmap_Height, SKIP_HEIGHT,\
     MUIA_FixWidth, SKIP_WIDTH,\
     MUIA_FixHeight, SKIP_HEIGHT,\
     MUIA_Bodychunk_Body, (UBYTE *)skip_body,\
     MUIA_Bodychunk_Compression, SKIP_COMPRESSION,\
     MUIA_Bodychunk_Masking, SKIP_MASKING,\
     MUIA_Bodychunk_Depth, SKIP_DEPTH,\
     MUIA_Bitmap_SourceColors, skip_colors,\
     MUIA_Bitmap_Transparent, 0,\
     End

#define IMG2 \
     BodychunkObject,\
     MUIA_Bitmap_Width, GET_WIDTH,\
     MUIA_Bitmap_Height, GET_HEIGHT,\
     MUIA_FixWidth, GET_WIDTH,\
     MUIA_FixHeight, GET_HEIGHT,\
     MUIA_Bodychunk_Body, (UBYTE *)get_body,\
     MUIA_Bodychunk_Compression, GET_COMPRESSION,\
     MUIA_Bodychunk_Masking, GET_MASKING,\
     MUIA_Bodychunk_Depth, GET_DEPTH,\
     MUIA_Bitmap_SourceColors, get_colors,\
     MUIA_Bitmap_Transparent, 0,\
     End

#define IMG3 \
     BodychunkObject,\
     MUIA_Bitmap_Width, EXCL_WIDTH,\
     MUIA_Bitmap_Height, EXCL_HEIGHT,\
     MUIA_FixWidth, EXCL_WIDTH,\
     MUIA_FixHeight, EXCL_HEIGHT,\
     MUIA_Bodychunk_Body, (UBYTE *)excl_body,\
     MUIA_Bodychunk_Compression, EXCL_COMPRESSION,\
     MUIA_Bodychunk_Masking, EXCL_MASKING,\
     MUIA_Bodychunk_Depth, EXCL_DEPTH,\
     MUIA_Bitmap_SourceColors, excl_colors,\
     MUIA_Bitmap_Transparent, 0,\
     End

extern int do_connect(char *host, int port);
extern int ngets(char *p, int fd);
extern int nwrite(int socket, char *s);
extern int DisplayRequester(char *body, char *but);
extern void fail(APTR app, char *str);
extern int getSockAddr(const char *host, int port, struct sockaddr_in *addr);
extern int inetconn (const struct sockaddr_in * addr);
extern void init(void);
extern void LoadNewsgroups(void);
extern void SAVEDS ASM AddNewsGroup(void);
extern void SAVEDS ASM AddNewsGroupManual(void);
extern int getconfig(void);
extern void SAVEDS SaveConfig(void);
extern APTR SAVEDS ASM ListConstruct(register __a2 APTR pool GNUCREG(a2), register __a1 char *ng GNUCREG(a1));
extern void SAVEDS ASM ListDestruct(register __a2 APTR pool GNUCREG(a2), register __a1 struct SelectedNG *ng GNUCREG(a1));
extern APTR SAVEDS ASM ServerConstruct(register __a2 APTR pool GNUCREG(a2), register __a1 char *server GNUCREG(a1));
extern void SAVEDS ASM ServerDestruct(register __a2 APTR pool GNUCREG(a2), register __a1 struct Server *server GNUCREG(a1));
extern int SAVEDS ASM ServerDisplay(register __a2 char **array GNUCREG(a2), register __a1 struct Server *srv GNUCREG(a1));
extern void SAVEDS AddServer(void);

extern void SAVEDS ASM ObjStrFunc(register __a2 APTR pop GNUCREG(a2), register __a1 APTR str GNUCREG(a1));

extern int ASM SAVEDS SelectServer(register __a1 int *data GNUCREG(a1));
extern void SAVEDS SetNGServer(void);
extern int SAVEDS ASM ChangeStatus(register __a2 char **array GNUCREG(a2), register __a1 long *pos GNUCREG(a1));
extern int SAVEDS ASM ListDisplay(register __a2 char **array GNUCREG(a2), register __a1 struct SelectedNG *ng GNUCREG(a1));

extern APTR SAVEDS ASM FilterConstruct(register __a2 APTR pool GNUCREG(a2), register __a1 struct Score *newscore GNUCREG(a1));
extern void SAVEDS ASM FilterDestruct(register __a2 APTR pool GNUCREG(a2), register __a1 struct Score *newscore GNUCREG(a1));
extern int SAVEDS ASM FilterDisplay(register __a2 char **array GNUCREG(a2), register __a1 struct Score *newscore GNUCREG(a1));
extern void SAVEDS ASM GetPath(void);
extern void SAVEDS ASM SetPath(void);
extern void SAVEDS DeleteEntry(void);
extern void SAVEDS DeleteFilterEntry(void);
extern void SAVEDS ShowFilters(void);
extern void ASM SAVEDS AddFilter(void);
extern void ASM SAVEDS AddSubjectFilter(void);
extern struct Server * SAVEDS SetServer(void);
extern void SAVEDS DownLoadNewsgroups(void);
extern void SAVEDS Abort(void);
extern int main(int argc,char *argv[]);


/* application, window */

extern APTR app, window;

/* listviews */

extern APTR unselected_newsgroups, selected_newsgroups, score_list, server_list;

/* buttons */

extern APTR clearall, delete, cancel, save;

/* strings */

extern APTR maxkb, userid, pass, searchfor, poppath;
extern APTR username, postname, hostname, email, org, path, manual;

extern APTR start_action, stop_action, preselect_action;
extern APTR before_send_action, after_send_action;

/* pop ups */

extern APTR start_action_popup, stop_action_popup, preselect_action_popup;
extern APTR before_send_action_popup, after_send_action_popup;

/* sliders */

extern APTR localsize, flushheaders, init_fetch, preselect_type_obj;

/* server managament */

extern APTR server_name, server_port, server_add, server_del, transfer_win;
extern APTR set_server, server_win, server_done, server_cancel, dn_ng, abort_dn;

/* score file */
extern APTR field_value, field_cycle, field_score, field_update, field_not, field_add;
extern APTR field_delete, score_name, score_add;

extern APTR busy, progress;

extern long flushthreshold,
            preselect_type,
            abort_download;

extern struct Hook server_construct_hook;
extern struct Hook server_destruct_hook;
extern struct Hook server_display_hook;

#endif

